blob: 979848d82fab562bed36ecb2a609baa202b3ea8f [file] [log] [blame]
Scott Anderson1a5fc952012-03-07 17:15:06 -08001function hmm() {
The Android Open Source Projectb6c1cf62008-10-21 07:00:00 -07002cat <<EOF
Jeff Gastonc6dfc4e2017-05-30 17:12:37 -07003
4Run "m help" for help with the build system itself.
5
The Android Open Source Projectdcc08f02008-12-17 18:03:49 -08006Invoke ". build/envsetup.sh" from your shell to add the following functions to your environment:
Steven Moreland62054a42018-12-06 10:11:40 -08007- lunch: lunch <product_name>-<build_variant>
8 Selects <product_name> as the product to build, and <build_variant> as the variant to
9 build, and stores those selections in the environment to be read by subsequent
10 invocations of 'm' etc.
Elliott Hughesf71c05a2020-03-06 16:46:59 -080011- tapas: tapas [<App1> <App2> ...] [arm|x86|arm64|x86_64] [eng|userdebug|user]
Martin Stjernholmf692c752021-04-12 00:01:10 +010012 Sets up the build environment for building unbundled apps (APKs).
13- banchan: banchan <module1> [<module2> ...] [arm|x86|arm64|x86_64] [eng|userdebug|user]
14 Sets up the build environment for building unbundled modules (APEXes).
Anton Hanssonece9c482019-02-04 18:15:39 +000015- croot: Changes directory to the top of the tree, or a subdirectory thereof.
Steven Moreland62054a42018-12-06 10:11:40 -080016- m: Makes from the top of the tree.
Dan Willemsen67074fe2019-10-30 12:35:34 -070017- mm: Builds and installs all of the modules in the current directory, and their
18 dependencies.
19- mmm: Builds and installs all of the modules in the supplied directories, and their
20 dependencies.
Steven Moreland62054a42018-12-06 10:11:40 -080021 To limit the modules being built use the syntax: mmm dir/:target1,target2.
Dan Willemsen67074fe2019-10-30 12:35:34 -070022- mma: Same as 'mm'
23- mmma: Same as 'mmm'
Steven Moreland62054a42018-12-06 10:11:40 -080024- provision: Flash device with all required partitions. Options will be passed on to fastboot.
25- cgrep: Greps on all local C/C++ files.
26- ggrep: Greps on all local Gradle files.
Orion Hodson831472d2019-10-25 11:35:15 +010027- gogrep: Greps on all local Go files.
Steven Moreland62054a42018-12-06 10:11:40 -080028- jgrep: Greps on all local Java files.
Taesu Leeea0cecd2020-10-28 11:05:18 +090029- ktgrep: Greps on all local Kotlin files.
Steven Moreland62054a42018-12-06 10:11:40 -080030- resgrep: Greps on all local res/*.xml files.
31- mangrep: Greps on all local AndroidManifest.xml files.
Jaewoong Jung892d0fe2019-05-04 10:06:28 -070032- mgrep: Greps on all local Makefiles and *.bp files.
Jeff Sharkeyf17cddf2019-08-21 12:51:26 -060033- owngrep: Greps on all local OWNERS files.
Alistair Delva176e5342021-02-22 13:31:26 -080034- rsgrep: Greps on all local Rust files.
Steven Moreland62054a42018-12-06 10:11:40 -080035- sepgrep: Greps on all local sepolicy files.
36- sgrep: Greps on all local source files.
37- godir: Go to the directory containing a file.
38- allmod: List all modules.
39- gomod: Go to the directory containing a module.
Rett Berg78d1c932019-01-24 14:34:23 -080040- pathmod: Get the directory containing a module.
Cole Faust24c36db2021-01-23 02:39:37 +000041- outmod: Gets the location of a module's installed outputs with a certain extension.
Joe Onorato2c1aa472021-02-25 16:42:39 -080042- dirmods: Gets the modules defined in a given directory.
Cole Faust24c36db2021-01-23 02:39:37 +000043- installmod: Adb installs a module's built APK.
44- refreshmod: Refresh list of modules for allmod/gomod/pathmod/outmod/installmod.
Steven Moreland74114f12020-09-10 01:23:32 +000045- syswrite: Remount partitions (e.g. system.img) as writable, rebooting if necessary.
The Android Open Source Projectb6c1cf62008-10-21 07:00:00 -070046
Roland Levillain39341922015-10-20 12:48:19 +010047Environment options:
Steven Moreland115d1f52019-09-26 16:30:28 -070048- SANITIZE_HOST: Set to 'address' to use ASAN for all host modules.
Sasha Smundak9f27cc02019-01-31 13:25:31 -080049- ANDROID_QUIET_BUILD: set to 'true' to display only the essential messages.
Dan Albert4ae5d4b2014-10-31 16:23:08 -070050
The Android Open Source Projectb6c1cf62008-10-21 07:00:00 -070051Look at the source to view more functions. The complete list is:
52EOF
Christopher Ferris55257d22017-03-23 11:08:58 -070053 local T=$(gettop)
54 local A=""
55 local i
Jacky Cao89483b82015-05-15 22:12:53 +080056 for i in `cat $T/build/envsetup.sh | sed -n "/^[[:blank:]]*function /s/function \([a-z_]*\).*/\1/p" | sort | uniq`; do
The Android Open Source Projectb6c1cf62008-10-21 07:00:00 -070057 A="$A $i"
58 done
59 echo $A
60}
61
Ying Wang08800fd2016-03-03 20:57:21 -080062# Get all the build variables needed by this script in a single call to the build system.
Matt Alexanderd9c56562020-05-21 10:49:17 +000063function build_build_var_cache()
64{
Christopher Ferris55257d22017-03-23 11:08:58 -070065 local T=$(gettop)
Ying Wang08800fd2016-03-03 20:57:21 -080066 # Grep out the variable names from the script.
Jim Tanga881a252018-06-19 16:34:41 +080067 cached_vars=(`cat $T/build/envsetup.sh | tr '()' ' ' | awk '{for(i=1;i<=NF;i++) if($i~/get_build_var/) print $(i+1)}' | sort -u | tr '\n' ' '`)
68 cached_abs_vars=(`cat $T/build/envsetup.sh | tr '()' ' ' | awk '{for(i=1;i<=NF;i++) if($i~/get_abs_build_var/) print $(i+1)}' | sort -u | tr '\n' ' '`)
Ying Wang08800fd2016-03-03 20:57:21 -080069 # Call the build system to dump the "<val>=<value>" pairs as a shell script.
Steven Moreland05402962018-01-05 12:13:11 -080070 build_dicts_script=`\builtin cd $T; build/soong/soong_ui.bash --dumpvars-mode \
Jim Tanga881a252018-06-19 16:34:41 +080071 --vars="${cached_vars[*]}" \
72 --abs-vars="${cached_abs_vars[*]}" \
Dan Willemsenaf88c412017-07-14 11:29:44 -070073 --var-prefix=var_cache_ \
74 --abs-var-prefix=abs_var_cache_`
Ying Wang08800fd2016-03-03 20:57:21 -080075 local ret=$?
Matt Alexanderd9c56562020-05-21 10:49:17 +000076 if [ $ret -ne 0 ]
77 then
Ying Wang08800fd2016-03-03 20:57:21 -080078 unset build_dicts_script
79 return $ret
80 fi
Dan Willemsenaf88c412017-07-14 11:29:44 -070081 # Execute the script to store the "<val>=<value>" pairs as shell variables.
Ying Wang08800fd2016-03-03 20:57:21 -080082 eval "$build_dicts_script"
Ying Wang08800fd2016-03-03 20:57:21 -080083 ret=$?
Ying Wangf0cb3972016-03-04 13:56:23 -080084 unset build_dicts_script
Matt Alexanderd9c56562020-05-21 10:49:17 +000085 if [ $ret -ne 0 ]
86 then
Ying Wang08800fd2016-03-03 20:57:21 -080087 return $ret
88 fi
89 BUILD_VAR_CACHE_READY="true"
90}
91
Ying Wangf0cb3972016-03-04 13:56:23 -080092# Delete the build var cache, so that we can still call into the build system
Ying Wang08800fd2016-03-03 20:57:21 -080093# to get build variables not listed in this script.
Matt Alexanderd9c56562020-05-21 10:49:17 +000094function destroy_build_var_cache()
95{
Ying Wang08800fd2016-03-03 20:57:21 -080096 unset BUILD_VAR_CACHE_READY
Christopher Ferris55257d22017-03-23 11:08:58 -070097 local v
Ying Wang08800fd2016-03-03 20:57:21 -080098 for v in $cached_vars; do
99 unset var_cache_$v
100 done
101 unset cached_vars
102 for v in $cached_abs_vars; do
103 unset abs_var_cache_$v
104 done
105 unset cached_abs_vars
106}
107
The Android Open Source Projectb6c1cf62008-10-21 07:00:00 -0700108# Get the value of a build variable as an absolute path.
Matt Alexanderd9c56562020-05-21 10:49:17 +0000109function get_abs_build_var()
110{
111 if [ "$BUILD_VAR_CACHE_READY" = "true" ]
112 then
Vishwath Mohan7d35f002016-03-11 10:00:40 -0800113 eval "echo \"\${abs_var_cache_$1}\""
Timi0469c3f2021-04-15 16:41:18 +0200114 return
Ying Wang08800fd2016-03-03 20:57:21 -0800115 fi
116
Christopher Ferris55257d22017-03-23 11:08:58 -0700117 local T=$(gettop)
The Android Open Source Projectb6c1cf62008-10-21 07:00:00 -0700118 if [ ! "$T" ]; then
119 echo "Couldn't locate the top of the tree. Try setting TOP." >&2
120 return
121 fi
Dan Willemsenaf88c412017-07-14 11:29:44 -0700122 (\cd $T; build/soong/soong_ui.bash --dumpvar-mode --abs $1)
The Android Open Source Projectb6c1cf62008-10-21 07:00:00 -0700123}
124
125# Get the exact value of a build variable.
Matt Alexanderd9c56562020-05-21 10:49:17 +0000126function get_build_var()
127{
128 if [ "$BUILD_VAR_CACHE_READY" = "true" ]
129 then
Vishwath Mohan7d35f002016-03-11 10:00:40 -0800130 eval "echo \"\${var_cache_$1}\""
Roland Levillain23c46cf2020-03-31 16:11:05 +0100131 return 0
Ying Wang08800fd2016-03-03 20:57:21 -0800132 fi
133
Christopher Ferris55257d22017-03-23 11:08:58 -0700134 local T=$(gettop)
The Android Open Source Projectb6c1cf62008-10-21 07:00:00 -0700135 if [ ! "$T" ]; then
136 echo "Couldn't locate the top of the tree. Try setting TOP." >&2
Roland Levillain23c46cf2020-03-31 16:11:05 +0100137 return 1
The Android Open Source Projectb6c1cf62008-10-21 07:00:00 -0700138 fi
Dan Willemsenaf88c412017-07-14 11:29:44 -0700139 (\cd $T; build/soong/soong_ui.bash --dumpvar-mode $1)
The Android Open Source Projectdcc08f02008-12-17 18:03:49 -0800140}
141
142# check to see if the supplied product is one we can build
Matt Alexanderd9c56562020-05-21 10:49:17 +0000143function check_product()
144{
Christopher Ferris55257d22017-03-23 11:08:58 -0700145 local T=$(gettop)
The Android Open Source Projectdcc08f02008-12-17 18:03:49 -0800146 if [ ! "$T" ]; then
147 echo "Couldn't locate the top of the tree. Try setting TOP." >&2
148 return
149 fi
Jeff Browne33ba4c2011-07-11 22:11:46 -0700150 TARGET_PRODUCT=$1 \
151 TARGET_BUILD_VARIANT= \
152 TARGET_BUILD_TYPE= \
Joe Onoratoda12daf2010-06-09 18:18:31 -0700153 TARGET_BUILD_APPS= \
The Android Open Source Projectdcc08f02008-12-17 18:03:49 -0800154 get_build_var TARGET_DEVICE > /dev/null
155 # hide successful answers, but allow the errors to show
156}
157
158VARIANT_CHOICES=(user userdebug eng)
159
160# check to see if the supplied variant is valid
Matt Alexanderd9c56562020-05-21 10:49:17 +0000161function check_variant()
162{
Christopher Ferris55257d22017-03-23 11:08:58 -0700163 local v
The Android Open Source Projectdcc08f02008-12-17 18:03:49 -0800164 for v in ${VARIANT_CHOICES[@]}
165 do
Matt Alexanderd9c56562020-05-21 10:49:17 +0000166 if [ "$v" = "$1" ]
167 then
The Android Open Source Projectdcc08f02008-12-17 18:03:49 -0800168 return 0
169 fi
170 done
171 return 1
The Android Open Source Projectb6c1cf62008-10-21 07:00:00 -0700172}
173
Matt Alexanderd9c56562020-05-21 10:49:17 +0000174function setpaths()
175{
Christopher Ferris55257d22017-03-23 11:08:58 -0700176 local T=$(gettop)
The Android Open Source Projectb6c1cf62008-10-21 07:00:00 -0700177 if [ ! "$T" ]; then
178 echo "Couldn't locate the top of the tree. Try setting TOP."
179 return
180 fi
181
182 ##################################################################
183 # #
184 # Read me before you modify this code #
185 # #
186 # This function sets ANDROID_BUILD_PATHS to what it is adding #
187 # to PATH, and the next time it is run, it removes that from #
188 # PATH. This is required so lunch can be run more than once #
189 # and still have working paths. #
190 # #
191 ##################################################################
192
Raphael Mollc639c782011-06-20 17:25:01 -0700193 # Note: on windows/cygwin, ANDROID_BUILD_PATHS will contain spaces
194 # due to "C:\Program Files" being in the path.
195
The Android Open Source Projectb6c1cf62008-10-21 07:00:00 -0700196 # out with the old
Matt Alexanderd9c56562020-05-21 10:49:17 +0000197 if [ -n "$ANDROID_BUILD_PATHS" ] ; then
The Android Open Source Projectb6c1cf62008-10-21 07:00:00 -0700198 export PATH=${PATH/$ANDROID_BUILD_PATHS/}
199 fi
Matt Alexanderd9c56562020-05-21 10:49:17 +0000200 if [ -n "$ANDROID_PRE_BUILD_PATHS" ] ; then
Doug Zongker29034982011-04-22 08:16:56 -0700201 export PATH=${PATH/$ANDROID_PRE_BUILD_PATHS/}
Ying Wangaa1c9b52012-11-26 20:51:59 -0800202 # strip leading ':', if any
203 export PATH=${PATH/:%/}
Jeff Hamilton4a1c70e2010-06-21 18:26:38 -0500204 fi
The Android Open Source Projectb6c1cf62008-10-21 07:00:00 -0700205
206 # and in with the new
Christopher Ferris55257d22017-03-23 11:08:58 -0700207 local prebuiltdir=$(getprebuilt)
208 local gccprebuiltdir=$(get_abs_build_var ANDROID_GCC_PREBUILTS)
Raphael732936d2011-06-22 14:35:32 -0700209
Ben Cheng8bc4c432012-11-16 13:29:13 -0800210 # defined in core/config.mk
Christopher Ferris55257d22017-03-23 11:08:58 -0700211 local targetgccversion=$(get_build_var TARGET_GCC_VERSION)
212 local targetgccversion2=$(get_build_var 2ND_TARGET_GCC_VERSION)
Ben Cheng15266702012-12-10 16:04:39 -0800213 export TARGET_GCC_VERSION=$targetgccversion
Ben Cheng8bc4c432012-11-16 13:29:13 -0800214
Raphael Mollc639c782011-06-20 17:25:01 -0700215 # The gcc toolchain does not exists for windows/cygwin. In this case, do not reference it.
Ben Chengfba67bf2014-02-25 10:27:07 -0800216 export ANDROID_TOOLCHAIN=
217 export ANDROID_TOOLCHAIN_2ND_ARCH=
David 'Digit' Turner2056c252012-04-17 14:50:47 +0200218 local ARCH=$(get_build_var TARGET_ARCH)
Christopher Ferris55257d22017-03-23 11:08:58 -0700219 local toolchaindir toolchaindir2=
David 'Digit' Turner2056c252012-04-17 14:50:47 +0200220 case $ARCH in
Matt Alexanderd9c56562020-05-21 10:49:17 +0000221 x86) toolchaindir=x86/x86_64-linux-android-$targetgccversion/bin
Mark D Horn7d0ede72012-03-14 14:20:30 -0700222 ;;
Matt Alexanderd9c56562020-05-21 10:49:17 +0000223 x86_64) toolchaindir=x86/x86_64-linux-android-$targetgccversion/bin
Pavel Chupinfd82a492012-11-26 09:50:07 +0400224 ;;
Matt Alexanderd9c56562020-05-21 10:49:17 +0000225 arm) toolchaindir=arm/arm-linux-androideabi-$targetgccversion/bin
David 'Digit' Turner2056c252012-04-17 14:50:47 +0200226 ;;
Matt Alexanderd9c56562020-05-21 10:49:17 +0000227 arm64) toolchaindir=aarch64/aarch64-linux-android-$targetgccversion/bin;
228 toolchaindir2=arm/arm-linux-androideabi-$targetgccversion2/bin
Ben Chengdb4fc202013-10-04 16:02:59 -0700229 ;;
David 'Digit' Turner2056c252012-04-17 14:50:47 +0200230 *)
231 echo "Can't find toolchain for unknown architecture: $ARCH"
232 toolchaindir=xxxxxxxxx
Mark D Horn7d0ede72012-03-14 14:20:30 -0700233 ;;
234 esac
Jing Yuf5172c72012-03-29 20:45:50 -0700235 if [ -d "$gccprebuiltdir/$toolchaindir" ]; then
Ben Chengfba67bf2014-02-25 10:27:07 -0800236 export ANDROID_TOOLCHAIN=$gccprebuiltdir/$toolchaindir
Raphael Mollc639c782011-06-20 17:25:01 -0700237 fi
Raphael732936d2011-06-22 14:35:32 -0700238
Christopher Ferris55257d22017-03-23 11:08:58 -0700239 if [ "$toolchaindir2" -a -d "$gccprebuiltdir/$toolchaindir2" ]; then
Ben Chengfba67bf2014-02-25 10:27:07 -0800240 export ANDROID_TOOLCHAIN_2ND_ARCH=$gccprebuiltdir/$toolchaindir2
241 fi
242
Dan Willemsen838dcec2021-09-30 22:40:34 +0000243 export ANDROID_DEV_SCRIPTS=$T/development/scripts:$T/prebuilts/devtools/tools
Yueyao Zhuefc786a2017-04-07 14:11:54 -0700244
245 # add kernel specific binaries
246 case $(uname -s) in
247 Linux)
248 export ANDROID_DEV_SCRIPTS=$ANDROID_DEV_SCRIPTS:$T/prebuilts/misc/linux-x86/dtc:$T/prebuilts/misc/linux-x86/libufdt
249 ;;
250 *)
251 ;;
252 esac
253
Torne (Richard Coles)0091bae2017-10-03 16:31:18 -0400254 ANDROID_BUILD_PATHS=$(get_build_var ANDROID_BUILD_PATHS):$ANDROID_TOOLCHAIN
Martin Stjernholm6a012262021-11-24 14:56:15 +0000255 ANDROID_BUILD_PATHS=$ANDROID_BUILD_PATHS:$ANDROID_TOOLCHAIN_2ND_ARCH
Yi Kongdfd00b12019-05-21 16:00:04 -0700256 ANDROID_BUILD_PATHS=$ANDROID_BUILD_PATHS:$ANDROID_DEV_SCRIPTS
257
258 # Append llvm binutils prebuilts path to ANDROID_BUILD_PATHS.
259 local ANDROID_LLVM_BINUTILS=$(get_abs_build_var ANDROID_CLANG_PREBUILTS)/llvm-binutils-stable
260 ANDROID_BUILD_PATHS=$ANDROID_BUILD_PATHS:$ANDROID_LLVM_BINUTILS
David 'Digit' Turner94d16e52014-05-05 16:13:50 +0200261
Stephen Hinesaa8d72c2020-02-04 09:15:18 -0800262 # Set up ASAN_SYMBOLIZER_PATH for SANITIZE_HOST=address builds.
263 export ASAN_SYMBOLIZER_PATH=$ANDROID_LLVM_BINUTILS/llvm-symbolizer
264
David 'Digit' Turner94d16e52014-05-05 16:13:50 +0200265 # If prebuilts/android-emulator/<system>/ exists, prepend it to our PATH
266 # to ensure that the corresponding 'emulator' binaries are used.
267 case $(uname -s) in
268 Darwin)
269 ANDROID_EMULATOR_PREBUILTS=$T/prebuilts/android-emulator/darwin-x86_64
270 ;;
271 Linux)
272 ANDROID_EMULATOR_PREBUILTS=$T/prebuilts/android-emulator/linux-x86_64
273 ;;
274 *)
275 ANDROID_EMULATOR_PREBUILTS=
276 ;;
277 esac
278 if [ -n "$ANDROID_EMULATOR_PREBUILTS" -a -d "$ANDROID_EMULATOR_PREBUILTS" ]; then
Yi Kongdfd00b12019-05-21 16:00:04 -0700279 ANDROID_BUILD_PATHS=$ANDROID_BUILD_PATHS:$ANDROID_EMULATOR_PREBUILTS
David 'Digit' Turner94d16e52014-05-05 16:13:50 +0200280 export ANDROID_EMULATOR_PREBUILTS
281 fi
282
Jim Tangb3fda302018-12-22 10:24:55 +0800283 # Append asuite prebuilts path to ANDROID_BUILD_PATHS.
284 local os_arch=$(get_build_var HOST_PREBUILT_TAG)
Ryan Prichard8426a192019-07-15 18:05:29 -0700285 local ACLOUD_PATH="$T/prebuilts/asuite/acloud/$os_arch"
286 local AIDEGEN_PATH="$T/prebuilts/asuite/aidegen/$os_arch"
287 local ATEST_PATH="$T/prebuilts/asuite/atest/$os_arch"
Martin Stjernholm6a012262021-11-24 14:56:15 +0000288 ANDROID_BUILD_PATHS=$ANDROID_BUILD_PATHS:$ACLOUD_PATH:$AIDEGEN_PATH:$ATEST_PATH
Jim Tangb3fda302018-12-22 10:24:55 +0800289
Martin Stjernholm6a012262021-11-24 14:56:15 +0000290 export ANDROID_BUILD_PATHS=$(tr -s : <<<"${ANDROID_BUILD_PATHS}:")
Ryan Prichard8426a192019-07-15 18:05:29 -0700291 export PATH=$ANDROID_BUILD_PATHS$PATH
Jim Tang22f4c322018-12-17 15:21:53 +0800292
293 # out with the duplicate old
294 if [ -n $ANDROID_PYTHONPATH ]; then
295 export PYTHONPATH=${PYTHONPATH//$ANDROID_PYTHONPATH/}
296 fi
297 # and in with the new
298 export ANDROID_PYTHONPATH=$T/development/python-packages:
Jim Tangc4dba1d2019-07-25 16:54:27 +0800299 if [ -n $VENDOR_PYTHONPATH ]; then
300 ANDROID_PYTHONPATH=$ANDROID_PYTHONPATH$VENDOR_PYTHONPATH
301 fi
Jim Tang22f4c322018-12-17 15:21:53 +0800302 export PYTHONPATH=$ANDROID_PYTHONPATH$PYTHONPATH
The Android Open Source Projectdcc08f02008-12-17 18:03:49 -0800303
Colin Crosse97e6932017-06-30 16:01:45 -0700304 export ANDROID_JAVA_HOME=$(get_abs_build_var ANDROID_JAVA_HOME)
305 export JAVA_HOME=$ANDROID_JAVA_HOME
306 export ANDROID_JAVA_TOOLCHAIN=$(get_abs_build_var ANDROID_JAVA_TOOLCHAIN)
307 export ANDROID_PRE_BUILD_PATHS=$ANDROID_JAVA_TOOLCHAIN:
308 export PATH=$ANDROID_PRE_BUILD_PATHS$PATH
Jeff Hamilton4a1c70e2010-06-21 18:26:38 -0500309
The Android Open Source Projectdcc08f02008-12-17 18:03:49 -0800310 unset ANDROID_PRODUCT_OUT
The Android Open Source Projectb6c1cf62008-10-21 07:00:00 -0700311 export ANDROID_PRODUCT_OUT=$(get_abs_build_var PRODUCT_OUT)
312 export OUT=$ANDROID_PRODUCT_OUT
313
Jeff Brown8fd5cce2011-03-24 17:03:06 -0700314 unset ANDROID_HOST_OUT
315 export ANDROID_HOST_OUT=$(get_abs_build_var HOST_OUT)
316
Jiyong Parkc02b1c42020-11-03 11:06:39 +0900317 unset ANDROID_SOONG_HOST_OUT
318 export ANDROID_SOONG_HOST_OUT=$(get_abs_build_var SOONG_HOST_OUT)
319
Simran Basidd050ed2017-02-13 13:46:48 -0800320 unset ANDROID_HOST_OUT_TESTCASES
321 export ANDROID_HOST_OUT_TESTCASES=$(get_abs_build_var HOST_OUT_TESTCASES)
322
323 unset ANDROID_TARGET_OUT_TESTCASES
324 export ANDROID_TARGET_OUT_TESTCASES=$(get_abs_build_var TARGET_OUT_TESTCASES)
325
The Android Open Source Projectdcc08f02008-12-17 18:03:49 -0800326 # needed for building linux on MacOS
The Android Open Source Projectb6c1cf62008-10-21 07:00:00 -0700327 # TODO: fix the path
328 #export HOST_EXTRACFLAGS="-I "$T/system/kernel_headers/host_include
329}
330
Rupert Shuttleworth5d60d022020-10-25 05:20:03 +0000331function bazel()
Rupert Shuttleworth131fa7d2020-10-12 13:41:12 +0000332{
Jingwen Chen17d56992021-06-10 08:17:54 +0000333 if which bazel &>/dev/null; then
334 >&2 echo "NOTE: bazel() function sourced from Android's envsetup.sh is being used instead of $(which bazel)"
335 >&2 echo
Rupert Shuttleworth131fa7d2020-10-12 13:41:12 +0000336 fi
337
Jingwen Chen17d56992021-06-10 08:17:54 +0000338 local T="$(gettop)"
339 if [ ! "$T" ]; then
340 >&2 echo "Couldn't locate the top of the Android tree. Try setting TOP. This bazel() function cannot be used outside of the AOSP directory."
341 return
Rupert Shuttleworth131fa7d2020-10-12 13:41:12 +0000342 fi
343
Rupert Shuttleworth5d60d022020-10-25 05:20:03 +0000344 "$T/tools/bazel" "$@"
Rupert Shuttleworth131fa7d2020-10-12 13:41:12 +0000345}
346
Matt Alexanderd9c56562020-05-21 10:49:17 +0000347function printconfig()
348{
Christopher Ferris55257d22017-03-23 11:08:58 -0700349 local T=$(gettop)
The Android Open Source Projectdcc08f02008-12-17 18:03:49 -0800350 if [ ! "$T" ]; then
351 echo "Couldn't locate the top of the tree. Try setting TOP." >&2
352 return
353 fi
354 get_build_var report_config
The Android Open Source Projectb6c1cf62008-10-21 07:00:00 -0700355}
356
Matt Alexanderd9c56562020-05-21 10:49:17 +0000357function set_stuff_for_environment()
358{
The Android Open Source Projectdcc08f02008-12-17 18:03:49 -0800359 setpaths
360 set_sequence_number
The Android Open Source Projectb6c1cf62008-10-21 07:00:00 -0700361
The Android Open Source Projectdcc08f02008-12-17 18:03:49 -0800362 export ANDROID_BUILD_TOP=$(gettop)
Ben Chengaac3f812013-08-13 14:38:15 -0700363 # With this environment variable new GCC can apply colors to warnings/errors
364 export GCC_COLORS='error=01;31:warning=01;35:note=01;36:caret=01;32:locus=01:quote=01'
The Android Open Source Projectb6c1cf62008-10-21 07:00:00 -0700365}
366
Matt Alexanderd9c56562020-05-21 10:49:17 +0000367function set_sequence_number()
368{
Colin Cross88737132017-03-21 17:41:03 -0700369 export BUILD_ENV_SEQUENCE_NUMBER=13
The Android Open Source Projectb6c1cf62008-10-21 07:00:00 -0700370}
371
Makoto Onukida971062018-06-18 10:15:19 -0700372# Takes a command name, and check if it's in ENVSETUP_NO_COMPLETION or not.
373function should_add_completion() {
Jim Tanga881a252018-06-19 16:34:41 +0800374 local cmd="$(basename $1| sed 's/_completion//' |sed 's/\.\(.*\)*sh$//')"
Makoto Onukida971062018-06-18 10:15:19 -0700375 case :"$ENVSETUP_NO_COMPLETION": in
Jim Tanga881a252018-06-19 16:34:41 +0800376 *:"$cmd":*)
377 return 1
378 ;;
Makoto Onukida971062018-06-18 10:15:19 -0700379 esac
380 return 0
381}
382
Matt Alexanderd9c56562020-05-21 10:49:17 +0000383function addcompletions()
384{
Ben Taitelbaum8c2c9cf2020-09-22 16:45:05 -0700385 local f=
Kenny Root52aa81c2011-07-15 11:07:06 -0700386
Jim Tanga881a252018-06-19 16:34:41 +0800387 # Keep us from trying to run in something that's neither bash nor zsh.
388 if [ -z "$BASH_VERSION" -a -z "$ZSH_VERSION" ]; then
Kenny Root52aa81c2011-07-15 11:07:06 -0700389 return
390 fi
391
392 # Keep us from trying to run in bash that's too old.
Jim Tanga881a252018-06-19 16:34:41 +0800393 if [ -n "$BASH_VERSION" -a ${BASH_VERSINFO[0]} -lt 3 ]; then
Kenny Root52aa81c2011-07-15 11:07:06 -0700394 return
395 fi
396
Jim Tanga881a252018-06-19 16:34:41 +0800397 local completion_files=(
MÃ¥rten Kongstadcb5c73f2022-05-04 14:08:12 +0000398 packages/modules/adb/adb.bash
Jim Tanga881a252018-06-19 16:34:41 +0800399 system/core/fastboot/fastboot.bash
Jim Tangb3fda302018-12-22 10:24:55 +0800400 tools/asuite/asuite.sh
Jim Tanga881a252018-06-19 16:34:41 +0800401 )
Makoto Onukida971062018-06-18 10:15:19 -0700402 # Completion can be disabled selectively to allow users to use non-standard completion.
403 # e.g.
404 # ENVSETUP_NO_COMPLETION=adb # -> disable adb completion
405 # ENVSETUP_NO_COMPLETION=adb:bit # -> disable adb and bit completion
Usta Shrestha1433fb32022-05-13 14:49:40 -0400406 local T=$(gettop)
Jim Tanga881a252018-06-19 16:34:41 +0800407 for f in ${completion_files[*]}; do
Usta Shrestha1433fb32022-05-13 14:49:40 -0400408 f="$T/$f"
MÃ¥rten Kongstadcb5c73f2022-05-04 14:08:12 +0000409 if [ ! -f "$f" ]; then
410 echo "Warning: completion file $f not found"
411 elif should_add_completion "$f"; then
Kenny Root52aa81c2011-07-15 11:07:06 -0700412 . $f
Elliott Hughesce18dd42018-04-03 13:49:48 -0700413 fi
414 done
Joe Onorato002a6c72016-10-20 16:39:49 -0700415
Matt Alexanderd9c56562020-05-21 10:49:17 +0000416 if should_add_completion bit ; then
Makoto Onukida971062018-06-18 10:15:19 -0700417 complete -C "bit --tab" bit
418 fi
Anton Hanssonece9c482019-02-04 18:15:39 +0000419 if [ -z "$ZSH_VERSION" ]; then
420 # Doesn't work in zsh.
421 complete -o nospace -F _croot croot
422 fi
Jim Tanga881a252018-06-19 16:34:41 +0800423 complete -F _lunch lunch
Steven Moreland62054a42018-12-06 10:11:40 -0800424
Cole Faust24c36db2021-01-23 02:39:37 +0000425 complete -F _complete_android_module_names pathmod
dimitry73b84812018-12-11 18:06:00 +0100426 complete -F _complete_android_module_names gomod
Cole Faust24c36db2021-01-23 02:39:37 +0000427 complete -F _complete_android_module_names outmod
428 complete -F _complete_android_module_names installmod
dimitry73b84812018-12-11 18:06:00 +0100429 complete -F _complete_android_module_names m
Kenny Root52aa81c2011-07-15 11:07:06 -0700430}
431
Joe Onorato824608c2022-04-08 11:06:16 -0700432function multitree_lunch_help()
433{
434 echo "usage: lunch PRODUCT-VARIANT" 1>&2
435 echo " Set up android build environment based on a product short name and variant" 1>&2
436 echo 1>&2
437 echo "lunch COMBO_FILE VARIANT" 1>&2
438 echo " Set up android build environment based on a specific lunch combo file" 1>&2
439 echo " and variant." 1>&2
440 echo 1>&2
441 echo "lunch --print [CONFIG]" 1>&2
442 echo " Print the contents of a configuration. If CONFIG is supplied, that config" 1>&2
443 echo " will be flattened and printed. If CONFIG is not supplied, the currently" 1>&2
444 echo " selected config will be printed. Returns 0 on success or nonzero on error." 1>&2
445 echo 1>&2
446 echo "lunch --list" 1>&2
447 echo " List all possible combo files available in the current tree" 1>&2
448 echo 1>&2
449 echo "lunch --help" 1>&2
450 echo "lunch -h" 1>&2
451 echo " Prints this message." 1>&2
452}
453
454function multitree_lunch()
455{
456 local code
457 local results
458 if $(echo "$1" | grep -q '^-') ; then
459 # Calls starting with a -- argument are passed directly and the function
460 # returns with the lunch.py exit code.
Joe Onorato7cf6f972022-05-11 21:39:57 -0700461 build/build/make/orchestrator/core/lunch.py "$@"
Joe Onorato824608c2022-04-08 11:06:16 -0700462 code=$?
463 if [[ $code -eq 2 ]] ; then
464 echo 1>&2
465 multitree_lunch_help
466 return $code
467 elif [[ $code -ne 0 ]] ; then
468 return $code
469 fi
470 else
471 # All other calls go through the --lunch variant of lunch.py
Joe Onorato7cf6f972022-05-11 21:39:57 -0700472 results=($(build/build/make/orchestrator/core/lunch.py --lunch "$@"))
Joe Onorato824608c2022-04-08 11:06:16 -0700473 code=$?
474 if [[ $code -eq 2 ]] ; then
475 echo 1>&2
476 multitree_lunch_help
477 return $code
478 elif [[ $code -ne 0 ]] ; then
479 return $code
480 fi
481
482 export TARGET_BUILD_COMBO=${results[0]}
483 export TARGET_BUILD_VARIANT=${results[1]}
484 fi
485}
486
Matt Alexanderd9c56562020-05-21 10:49:17 +0000487function choosetype()
488{
The Android Open Source Projectb6c1cf62008-10-21 07:00:00 -0700489 echo "Build type choices are:"
490 echo " 1. release"
491 echo " 2. debug"
492 echo
493
The Android Open Source Projectdcc08f02008-12-17 18:03:49 -0800494 local DEFAULT_NUM DEFAULT_VALUE
Jeff Browne33ba4c2011-07-11 22:11:46 -0700495 DEFAULT_NUM=1
496 DEFAULT_VALUE=release
The Android Open Source Projectb6c1cf62008-10-21 07:00:00 -0700497
The Android Open Source Projectdcc08f02008-12-17 18:03:49 -0800498 export TARGET_BUILD_TYPE=
499 local ANSWER
The Android Open Source Projectb6c1cf62008-10-21 07:00:00 -0700500 while [ -z $TARGET_BUILD_TYPE ]
501 do
502 echo -n "Which would you like? ["$DEFAULT_NUM"] "
Matt Alexanderd9c56562020-05-21 10:49:17 +0000503 if [ -z "$1" ] ; then
The Android Open Source Projectdcc08f02008-12-17 18:03:49 -0800504 read ANSWER
505 else
506 echo $1
507 ANSWER=$1
508 fi
The Android Open Source Projectb6c1cf62008-10-21 07:00:00 -0700509 case $ANSWER in
510 "")
511 export TARGET_BUILD_TYPE=$DEFAULT_VALUE
512 ;;
513 1)
514 export TARGET_BUILD_TYPE=release
515 ;;
The Android Open Source Projectdcc08f02008-12-17 18:03:49 -0800516 release)
517 export TARGET_BUILD_TYPE=release
518 ;;
The Android Open Source Projectb6c1cf62008-10-21 07:00:00 -0700519 2)
520 export TARGET_BUILD_TYPE=debug
521 ;;
The Android Open Source Projectdcc08f02008-12-17 18:03:49 -0800522 debug)
523 export TARGET_BUILD_TYPE=debug
524 ;;
The Android Open Source Projectb6c1cf62008-10-21 07:00:00 -0700525 *)
526 echo
527 echo "I didn't understand your response. Please try again."
528 echo
The Android Open Source Projectb6c1cf62008-10-21 07:00:00 -0700529 ;;
530 esac
Matt Alexanderd9c56562020-05-21 10:49:17 +0000531 if [ -n "$1" ] ; then
The Android Open Source Projectdcc08f02008-12-17 18:03:49 -0800532 break
533 fi
The Android Open Source Projectb6c1cf62008-10-21 07:00:00 -0700534 done
535
Ying Wang08800fd2016-03-03 20:57:21 -0800536 build_build_var_cache
The Android Open Source Projectb6c1cf62008-10-21 07:00:00 -0700537 set_stuff_for_environment
Ying Wang08800fd2016-03-03 20:57:21 -0800538 destroy_build_var_cache
The Android Open Source Projectb6c1cf62008-10-21 07:00:00 -0700539}
540
The Android Open Source Projectdcc08f02008-12-17 18:03:49 -0800541#
542# This function isn't really right: It chooses a TARGET_PRODUCT
543# based on the list of boards. Usually, that gets you something
544# that kinda works with a generic product, but really, you should
545# pick a product by name.
546#
Matt Alexanderd9c56562020-05-21 10:49:17 +0000547function chooseproduct()
548{
Christopher Ferris55257d22017-03-23 11:08:58 -0700549 local default_value
Matt Alexanderd9c56562020-05-21 10:49:17 +0000550 if [ "x$TARGET_PRODUCT" != x ] ; then
The Android Open Source Projectb6c1cf62008-10-21 07:00:00 -0700551 default_value=$TARGET_PRODUCT
552 else
Ying Wang0a76df52015-06-08 11:57:26 -0700553 default_value=aosp_arm
The Android Open Source Projectb6c1cf62008-10-21 07:00:00 -0700554 fi
555
Ying Wang08800fd2016-03-03 20:57:21 -0800556 export TARGET_BUILD_APPS=
The Android Open Source Projectdcc08f02008-12-17 18:03:49 -0800557 export TARGET_PRODUCT=
558 local ANSWER
The Android Open Source Projectb6c1cf62008-10-21 07:00:00 -0700559 while [ -z "$TARGET_PRODUCT" ]
560 do
Joe Onorato8849aed2009-04-29 15:56:47 -0700561 echo -n "Which product would you like? [$default_value] "
Matt Alexanderd9c56562020-05-21 10:49:17 +0000562 if [ -z "$1" ] ; then
The Android Open Source Projectdcc08f02008-12-17 18:03:49 -0800563 read ANSWER
564 else
565 echo $1
566 ANSWER=$1
567 fi
568
Matt Alexanderd9c56562020-05-21 10:49:17 +0000569 if [ -z "$ANSWER" ] ; then
The Android Open Source Projectb6c1cf62008-10-21 07:00:00 -0700570 export TARGET_PRODUCT=$default_value
The Android Open Source Projectdcc08f02008-12-17 18:03:49 -0800571 else
Matt Alexanderd9c56562020-05-21 10:49:17 +0000572 if check_product $ANSWER
573 then
The Android Open Source Projectdcc08f02008-12-17 18:03:49 -0800574 export TARGET_PRODUCT=$ANSWER
575 else
576 echo "** Not a valid product: $ANSWER"
577 fi
578 fi
Matt Alexanderd9c56562020-05-21 10:49:17 +0000579 if [ -n "$1" ] ; then
The Android Open Source Projectdcc08f02008-12-17 18:03:49 -0800580 break
The Android Open Source Projectb6c1cf62008-10-21 07:00:00 -0700581 fi
582 done
583
Ying Wang08800fd2016-03-03 20:57:21 -0800584 build_build_var_cache
The Android Open Source Projectb6c1cf62008-10-21 07:00:00 -0700585 set_stuff_for_environment
Ying Wang08800fd2016-03-03 20:57:21 -0800586 destroy_build_var_cache
The Android Open Source Projectb6c1cf62008-10-21 07:00:00 -0700587}
588
Matt Alexanderd9c56562020-05-21 10:49:17 +0000589function choosevariant()
590{
The Android Open Source Projectdcc08f02008-12-17 18:03:49 -0800591 echo "Variant choices are:"
592 local index=1
593 local v
594 for v in ${VARIANT_CHOICES[@]}
595 do
596 # The product name is the name of the directory containing
597 # the makefile we found, above.
598 echo " $index. $v"
599 index=$(($index+1))
600 done
601
602 local default_value=eng
603 local ANSWER
604
605 export TARGET_BUILD_VARIANT=
606 while [ -z "$TARGET_BUILD_VARIANT" ]
607 do
608 echo -n "Which would you like? [$default_value] "
Matt Alexanderd9c56562020-05-21 10:49:17 +0000609 if [ -z "$1" ] ; then
The Android Open Source Projectdcc08f02008-12-17 18:03:49 -0800610 read ANSWER
611 else
612 echo $1
613 ANSWER=$1
614 fi
615
Matt Alexanderd9c56562020-05-21 10:49:17 +0000616 if [ -z "$ANSWER" ] ; then
The Android Open Source Projectdcc08f02008-12-17 18:03:49 -0800617 export TARGET_BUILD_VARIANT=$default_value
Matt Alexanderd9c56562020-05-21 10:49:17 +0000618 elif (echo -n $ANSWER | grep -q -e "^[0-9][0-9]*$") ; then
619 if [ "$ANSWER" -le "${#VARIANT_CHOICES[@]}" ] ; then
Guillaume Chelfice000fd2019-10-03 12:02:46 +0200620 export TARGET_BUILD_VARIANT=${VARIANT_CHOICES[@]:$(($ANSWER-1)):1}
The Android Open Source Projectdcc08f02008-12-17 18:03:49 -0800621 fi
622 else
Matt Alexanderd9c56562020-05-21 10:49:17 +0000623 if check_variant $ANSWER
624 then
The Android Open Source Projectdcc08f02008-12-17 18:03:49 -0800625 export TARGET_BUILD_VARIANT=$ANSWER
626 else
627 echo "** Not a valid variant: $ANSWER"
628 fi
629 fi
Matt Alexanderd9c56562020-05-21 10:49:17 +0000630 if [ -n "$1" ] ; then
The Android Open Source Projectdcc08f02008-12-17 18:03:49 -0800631 break
632 fi
633 done
634}
635
Matt Alexanderd9c56562020-05-21 10:49:17 +0000636function choosecombo()
637{
Jeff Browne33ba4c2011-07-11 22:11:46 -0700638 choosetype $1
The Android Open Source Projectb6c1cf62008-10-21 07:00:00 -0700639
640 echo
641 echo
Jeff Browne33ba4c2011-07-11 22:11:46 -0700642 chooseproduct $2
The Android Open Source Projectb6c1cf62008-10-21 07:00:00 -0700643
644 echo
645 echo
Jeff Browne33ba4c2011-07-11 22:11:46 -0700646 choosevariant $3
The Android Open Source Projectdcc08f02008-12-17 18:03:49 -0800647
648 echo
Ying Wang08800fd2016-03-03 20:57:21 -0800649 build_build_var_cache
The Android Open Source Projectb6c1cf62008-10-21 07:00:00 -0700650 set_stuff_for_environment
The Android Open Source Projectdcc08f02008-12-17 18:03:49 -0800651 printconfig
Ying Wang08800fd2016-03-03 20:57:21 -0800652 destroy_build_var_cache
The Android Open Source Projectb6c1cf62008-10-21 07:00:00 -0700653}
654
Matt Alexanderd9c56562020-05-21 10:49:17 +0000655function add_lunch_combo()
656{
Dan Willemsen5436c7e2019-02-11 21:31:47 -0800657 if [ -n "$ZSH_VERSION" ]; then
658 echo -n "${funcfiletrace[1]}: "
659 else
660 echo -n "${BASH_SOURCE[1]}:${BASH_LINENO[0]}: "
661 fi
662 echo "add_lunch_combo is obsolete. Use COMMON_LUNCH_CHOICES in your AndroidProducts.mk instead."
The Android Open Source Projectdcc08f02008-12-17 18:03:49 -0800663}
664
Matt Alexanderd9c56562020-05-21 10:49:17 +0000665function print_lunch_menu()
666{
The Android Open Source Projectb6c1cf62008-10-21 07:00:00 -0700667 local uname=$(uname)
Roland Levillain23c46cf2020-03-31 16:11:05 +0100668 local choices
Colin Crossfa50d402021-04-22 13:05:41 -0700669 choices=$(TARGET_BUILD_APPS= TARGET_PRODUCT= TARGET_BUILD_VARIANT= get_build_var COMMON_LUNCH_CHOICES 2>/dev/null)
Roland Levillain23c46cf2020-03-31 16:11:05 +0100670 local ret=$?
671
The Android Open Source Projectb6c1cf62008-10-21 07:00:00 -0700672 echo
673 echo "You're building on" $uname
The Android Open Source Projectb6c1cf62008-10-21 07:00:00 -0700674 echo
Roland Levillain23c46cf2020-03-31 16:11:05 +0100675
Matt Alexanderd9c56562020-05-21 10:49:17 +0000676 if [ $ret -ne 0 ]
677 then
Roland Levillain23c46cf2020-03-31 16:11:05 +0100678 echo "Warning: Cannot display lunch menu."
679 echo
680 echo "Note: You can invoke lunch with an explicit target:"
681 echo
682 echo " usage: lunch [target]" >&2
683 echo
684 return
685 fi
686
Will Burr40401202022-02-07 12:12:01 +0000687 echo "Lunch menu .. Here are the common combinations:"
The Android Open Source Projectdcc08f02008-12-17 18:03:49 -0800688
689 local i=1
690 local choice
Dan Willemsen91763e92019-10-03 15:13:12 -0700691 for choice in $(echo $choices)
The Android Open Source Projectdcc08f02008-12-17 18:03:49 -0800692 do
693 echo " $i. $choice"
694 i=$(($i+1))
695 done
696
The Android Open Source Projectb6c1cf62008-10-21 07:00:00 -0700697 echo
698}
699
Matt Alexanderd9c56562020-05-21 10:49:17 +0000700function lunch()
701{
The Android Open Source Projectdcc08f02008-12-17 18:03:49 -0800702 local answer
703
Steven Moreland92793dc2020-02-25 18:30:18 -0800704 if [[ $# -gt 1 ]]; then
705 echo "usage: lunch [target]" >&2
706 return 1
707 fi
708
Will Burr40401202022-02-07 12:12:01 +0000709 local used_lunch_menu=0
710
Steven Moreland92793dc2020-02-25 18:30:18 -0800711 if [ "$1" ]; then
The Android Open Source Projectdcc08f02008-12-17 18:03:49 -0800712 answer=$1
The Android Open Source Projectb6c1cf62008-10-21 07:00:00 -0700713 else
714 print_lunch_menu
Will Burr40401202022-02-07 12:12:01 +0000715 echo "Which would you like? [aosp_arm-eng]"
716 echo -n "Pick from common choices above (e.g. 13) or specify your own (e.g. aosp_barbet-eng): "
The Android Open Source Projectdcc08f02008-12-17 18:03:49 -0800717 read answer
Will Burr40401202022-02-07 12:12:01 +0000718 used_lunch_menu=1
The Android Open Source Projectb6c1cf62008-10-21 07:00:00 -0700719 fi
720
The Android Open Source Projectdcc08f02008-12-17 18:03:49 -0800721 local selection=
722
Matt Alexanderd9c56562020-05-21 10:49:17 +0000723 if [ -z "$answer" ]
724 then
Jean-Baptiste Queru324c1232013-03-22 15:53:54 -0700725 selection=aosp_arm-eng
Matt Alexanderd9c56562020-05-21 10:49:17 +0000726 elif (echo -n $answer | grep -q -e "^[0-9][0-9]*$")
727 then
Dan Willemsen5436c7e2019-02-11 21:31:47 -0800728 local choices=($(TARGET_BUILD_APPS= get_build_var COMMON_LUNCH_CHOICES))
Matt Alexanderd9c56562020-05-21 10:49:17 +0000729 if [ $answer -le ${#choices[@]} ]
730 then
Jim Tang0e3397b2018-10-03 18:25:50 +0800731 # array in zsh starts from 1 instead of 0.
Matt Alexanderd9c56562020-05-21 10:49:17 +0000732 if [ -n "$ZSH_VERSION" ]
733 then
Jim Tang0e3397b2018-10-03 18:25:50 +0800734 selection=${choices[$(($answer))]}
735 else
736 selection=${choices[$(($answer-1))]}
737 fi
The Android Open Source Projectdcc08f02008-12-17 18:03:49 -0800738 fi
Colin Cross88737132017-03-21 17:41:03 -0700739 else
The Android Open Source Projectdcc08f02008-12-17 18:03:49 -0800740 selection=$answer
The Android Open Source Projectb6c1cf62008-10-21 07:00:00 -0700741 fi
742
Joe Onoratoda12daf2010-06-09 18:18:31 -0700743 export TARGET_BUILD_APPS=
744
Colin Cross88737132017-03-21 17:41:03 -0700745 local product variant_and_version variant version
Colin Cross88737132017-03-21 17:41:03 -0700746 product=${selection%%-*} # Trim everything after first dash
747 variant_and_version=${selection#*-} # Trim everything up to first dash
748 if [ "$variant_and_version" != "$selection" ]; then
749 variant=${variant_and_version%%-*}
750 if [ "$variant" != "$variant_and_version" ]; then
751 version=${variant_and_version#*-}
752 fi
Jeff Browne33ba4c2011-07-11 22:11:46 -0700753 fi
The Android Open Source Projectdcc08f02008-12-17 18:03:49 -0800754
Matt Alexanderd9c56562020-05-21 10:49:17 +0000755 if [ -z "$product" ]
756 then
Ying Wang08800fd2016-03-03 20:57:21 -0800757 echo
Colin Cross88737132017-03-21 17:41:03 -0700758 echo "Invalid lunch combo: $selection"
Jeff Browne33ba4c2011-07-11 22:11:46 -0700759 return 1
760 fi
The Android Open Source Projectdcc08f02008-12-17 18:03:49 -0800761
Colin Cross88737132017-03-21 17:41:03 -0700762 TARGET_PRODUCT=$product \
763 TARGET_BUILD_VARIANT=$variant \
764 TARGET_PLATFORM_VERSION=$version \
765 build_build_var_cache
Matt Alexanderd9c56562020-05-21 10:49:17 +0000766 if [ $? -ne 0 ]
767 then
Anton Hansson32fa7ee2021-06-14 17:09:58 +0100768 if [[ "$product" =~ .*_(eng|user|userdebug) ]]
769 then
770 echo "Did you mean -${product/*_/}? (dash instead of underscore)"
771 fi
Colin Cross88737132017-03-21 17:41:03 -0700772 return 1
773 fi
Colin Cross88737132017-03-21 17:41:03 -0700774 export TARGET_PRODUCT=$(get_build_var TARGET_PRODUCT)
775 export TARGET_BUILD_VARIANT=$(get_build_var TARGET_BUILD_VARIANT)
Colin Crossb105e362017-05-01 14:21:28 -0700776 if [ -n "$version" ]; then
777 export TARGET_PLATFORM_VERSION=$(get_build_var TARGET_PLATFORM_VERSION)
778 else
779 unset TARGET_PLATFORM_VERSION
780 fi
Jeff Browne33ba4c2011-07-11 22:11:46 -0700781 export TARGET_BUILD_TYPE=release
The Android Open Source Projectb6c1cf62008-10-21 07:00:00 -0700782
Will Burr40401202022-02-07 12:12:01 +0000783 if [ $used_lunch_menu -eq 1 ]; then
784 echo
785 echo "Hint: next time you can simply run 'lunch $selection'"
786 fi
787
Sasha Smundak90d07bc2020-06-04 10:48:15 -0700788 [[ -n "${ANDROID_QUIET_BUILD:-}" ]] || echo
The Android Open Source Projectdcc08f02008-12-17 18:03:49 -0800789
The Android Open Source Projectb6c1cf62008-10-21 07:00:00 -0700790 set_stuff_for_environment
Sasha Smundak90d07bc2020-06-04 10:48:15 -0700791 [[ -n "${ANDROID_QUIET_BUILD:-}" ]] || printconfig
Ying Wang08800fd2016-03-03 20:57:21 -0800792 destroy_build_var_cache
The Android Open Source Projectb6c1cf62008-10-21 07:00:00 -0700793}
794
Dan Willemsenaf2e1f82018-04-04 15:41:41 -0700795unset COMMON_LUNCH_CHOICES_CACHE
Jeff Davidson513d7a42010-08-02 10:00:44 -0700796# Tab completion for lunch.
Matt Alexanderd9c56562020-05-21 10:49:17 +0000797function _lunch()
798{
Jeff Davidson513d7a42010-08-02 10:00:44 -0700799 local cur prev opts
800 COMPREPLY=()
801 cur="${COMP_WORDS[COMP_CWORD]}"
802 prev="${COMP_WORDS[COMP_CWORD-1]}"
803
Dan Willemsenaf2e1f82018-04-04 15:41:41 -0700804 if [ -z "$COMMON_LUNCH_CHOICES_CACHE" ]; then
Dan Willemsen5436c7e2019-02-11 21:31:47 -0800805 COMMON_LUNCH_CHOICES_CACHE=$(TARGET_BUILD_APPS= get_build_var COMMON_LUNCH_CHOICES)
Dan Willemsenaf2e1f82018-04-04 15:41:41 -0700806 fi
807
808 COMPREPLY=( $(compgen -W "${COMMON_LUNCH_CHOICES_CACHE}" -- ${cur}) )
Jeff Davidson513d7a42010-08-02 10:00:44 -0700809 return 0
810}
Jeff Davidson513d7a42010-08-02 10:00:44 -0700811
Joe Onoratoda12daf2010-06-09 18:18:31 -0700812# Configures the build to build unbundled apps.
Doug Zongker0d8179e2014-04-16 11:34:34 -0700813# Run tapas with one or more app names (from LOCAL_PACKAGE_NAME)
Matt Alexanderd9c56562020-05-21 10:49:17 +0000814function tapas()
815{
Jeff Gaston9fb05d82017-08-21 18:27:00 -0700816 local showHelp="$(echo $* | xargs -n 1 echo | \grep -E '^(help)$' | xargs)"
Elliott Hughesf71c05a2020-03-06 16:46:59 -0800817 local arch="$(echo $* | xargs -n 1 echo | \grep -E '^(arm|x86|arm64|x86_64)$' | xargs)"
Doug Zongker0d8179e2014-04-16 11:34:34 -0700818 local variant="$(echo $* | xargs -n 1 echo | \grep -E '^(user|userdebug|eng)$' | xargs)"
Jeff Hamilton5069bd62014-09-04 21:28:00 -0700819 local density="$(echo $* | xargs -n 1 echo | \grep -E '^(ldpi|mdpi|tvdpi|hdpi|xhdpi|xxhdpi|xxxhdpi|alldpi)$' | xargs)"
Elliott Hughesf71c05a2020-03-06 16:46:59 -0800820 local apps="$(echo $* | xargs -n 1 echo | \grep -E -v '^(user|userdebug|eng|arm|x86|arm64|x86_64|ldpi|mdpi|tvdpi|hdpi|xhdpi|xxhdpi|xxxhdpi|alldpi)$' | xargs)"
Joe Onoratoda12daf2010-06-09 18:18:31 -0700821
Jeff Gaston9fb05d82017-08-21 18:27:00 -0700822 if [ "$showHelp" != "" ]; then
823 $(gettop)/build/make/tapasHelp.sh
824 return
825 fi
826
Ying Wang67f02922012-08-22 10:25:20 -0700827 if [ $(echo $arch | wc -w) -gt 1 ]; then
828 echo "tapas: Error: Multiple build archs supplied: $arch"
829 return
830 fi
Joe Onoratoda12daf2010-06-09 18:18:31 -0700831 if [ $(echo $variant | wc -w) -gt 1 ]; then
832 echo "tapas: Error: Multiple build variants supplied: $variant"
833 return
834 fi
Jeff Hamilton5069bd62014-09-04 21:28:00 -0700835 if [ $(echo $density | wc -w) -gt 1 ]; then
836 echo "tapas: Error: Multiple densities supplied: $density"
837 return
838 fi
Ying Wang67f02922012-08-22 10:25:20 -0700839
Ying Wang0a76df52015-06-08 11:57:26 -0700840 local product=aosp_arm
Ying Wang67f02922012-08-22 10:25:20 -0700841 case $arch in
Matt Alexanderd9c56562020-05-21 10:49:17 +0000842 x86) product=aosp_x86;;
843 arm64) product=aosp_arm64;;
844 x86_64) product=aosp_x86_64;;
Ying Wang67f02922012-08-22 10:25:20 -0700845 esac
Joe Onoratoda12daf2010-06-09 18:18:31 -0700846 if [ -z "$variant" ]; then
847 variant=eng
848 fi
Ying Wangc048c9b2010-06-24 15:08:33 -0700849 if [ -z "$apps" ]; then
850 apps=all
851 fi
Justin Morey29d225c2014-11-04 13:35:51 -0600852 if [ -z "$density" ]; then
853 density=alldpi
854 fi
Joe Onoratoda12daf2010-06-09 18:18:31 -0700855
Ying Wang67f02922012-08-22 10:25:20 -0700856 export TARGET_PRODUCT=$product
Joe Onoratoda12daf2010-06-09 18:18:31 -0700857 export TARGET_BUILD_VARIANT=$variant
Jeff Hamilton5069bd62014-09-04 21:28:00 -0700858 export TARGET_BUILD_DENSITY=$density
Joe Onoratoda12daf2010-06-09 18:18:31 -0700859 export TARGET_BUILD_TYPE=release
860 export TARGET_BUILD_APPS=$apps
861
Ying Wang08800fd2016-03-03 20:57:21 -0800862 build_build_var_cache
Joe Onoratoda12daf2010-06-09 18:18:31 -0700863 set_stuff_for_environment
864 printconfig
Ying Wang08800fd2016-03-03 20:57:21 -0800865 destroy_build_var_cache
Joe Onoratoda12daf2010-06-09 18:18:31 -0700866}
867
Martin Stjernholmf692c752021-04-12 00:01:10 +0100868# Configures the build to build unbundled Android modules (APEXes).
869# Run banchan with one or more module names (from apex{} modules).
870function banchan()
871{
872 local showHelp="$(echo $* | xargs -n 1 echo | \grep -E '^(help)$' | xargs)"
Martin Stjernholm2b8d9232021-04-16 20:45:03 +0100873 local product="$(echo $* | xargs -n 1 echo | \grep -E '^(.*_)?(arm|x86|arm64|x86_64)$' | xargs)"
Martin Stjernholmf692c752021-04-12 00:01:10 +0100874 local variant="$(echo $* | xargs -n 1 echo | \grep -E '^(user|userdebug|eng)$' | xargs)"
Martin Stjernholm2b8d9232021-04-16 20:45:03 +0100875 local apps="$(echo $* | xargs -n 1 echo | \grep -E -v '^(user|userdebug|eng|(.*_)?(arm|x86|arm64|x86_64))$' | xargs)"
Martin Stjernholmf692c752021-04-12 00:01:10 +0100876
877 if [ "$showHelp" != "" ]; then
878 $(gettop)/build/make/banchanHelp.sh
879 return
880 fi
881
Martin Stjernholm2b8d9232021-04-16 20:45:03 +0100882 if [ -z "$product" ]; then
883 product=arm
884 elif [ $(echo $product | wc -w) -gt 1 ]; then
885 echo "banchan: Error: Multiple build archs or products supplied: $products"
Martin Stjernholmf692c752021-04-12 00:01:10 +0100886 return
887 fi
888 if [ $(echo $variant | wc -w) -gt 1 ]; then
889 echo "banchan: Error: Multiple build variants supplied: $variant"
890 return
891 fi
892 if [ -z "$apps" ]; then
893 echo "banchan: Error: No modules supplied"
894 return
895 fi
896
Martin Stjernholm2b8d9232021-04-16 20:45:03 +0100897 case $product in
898 arm) product=module_arm;;
Martin Stjernholmf692c752021-04-12 00:01:10 +0100899 x86) product=module_x86;;
900 arm64) product=module_arm64;;
901 x86_64) product=module_x86_64;;
902 esac
903 if [ -z "$variant" ]; then
904 variant=eng
905 fi
906
907 export TARGET_PRODUCT=$product
908 export TARGET_BUILD_VARIANT=$variant
909 export TARGET_BUILD_DENSITY=alldpi
910 export TARGET_BUILD_TYPE=release
911
912 # This setup currently uses TARGET_BUILD_APPS just like tapas, but the use
913 # case is different and it may diverge in the future.
914 export TARGET_BUILD_APPS=$apps
915
916 build_build_var_cache
917 set_stuff_for_environment
918 printconfig
919 destroy_build_var_cache
920}
921
Matt Alexanderd9c56562020-05-21 10:49:17 +0000922function gettop
923{
Colin Cross6cdc5d22017-10-20 11:37:33 -0700924 local TOPFILE=build/make/core/envsetup.mk
Matt Alexanderd9c56562020-05-21 10:49:17 +0000925 if [ -n "$TOP" -a -f "$TOP/$TOPFILE" ] ; then
Brian Carlstroma5c4f172014-09-12 00:33:25 -0700926 # The following circumlocution ensures we remove symlinks from TOP.
Patrice Arrudaaa4b8242020-10-12 21:29:14 +0000927 (cd "$TOP"; PWD= /bin/pwd)
The Android Open Source Projectb6c1cf62008-10-21 07:00:00 -0700928 else
Matt Alexanderd9c56562020-05-21 10:49:17 +0000929 if [ -f $TOPFILE ] ; then
Dan Bornsteind0b274d2009-11-24 15:48:50 -0800930 # The following circumlocution (repeated below as well) ensures
931 # that we record the true directory name and not one that is
932 # faked up with symlink names.
933 PWD= /bin/pwd
The Android Open Source Projectb6c1cf62008-10-21 07:00:00 -0700934 else
The Android Open Source Projectdcc08f02008-12-17 18:03:49 -0800935 local HERE=$PWD
Christopher Ferris55257d22017-03-23 11:08:58 -0700936 local T=
Patrice Arrudaaa4b8242020-10-12 21:29:14 +0000937 while [ \( ! \( -f $TOPFILE \) \) -a \( "$PWD" != "/" \) ]; do
Ying Wang9cd17642012-12-13 10:52:07 -0800938 \cd ..
synergyb112a402013-07-05 19:47:47 -0700939 T=`PWD= /bin/pwd -P`
The Android Open Source Projectb6c1cf62008-10-21 07:00:00 -0700940 done
Patrice Arrudaaa4b8242020-10-12 21:29:14 +0000941 \cd "$HERE"
The Android Open Source Projectb6c1cf62008-10-21 07:00:00 -0700942 if [ -f "$T/$TOPFILE" ]; then
Patrice Arrudaaa4b8242020-10-12 21:29:14 +0000943 echo "$T"
The Android Open Source Projectb6c1cf62008-10-21 07:00:00 -0700944 fi
945 fi
946 fi
947}
948
Joe Onorato7cf6f972022-05-11 21:39:57 -0700949# TODO: Merge into gettop as part of launching multitree
950function multitree_gettop
951{
952 local TOPFILE=build/build/make/core/envsetup.mk
953 if [ -n "$TOP" -a -f "$TOP/$TOPFILE" ] ; then
954 # The following circumlocution ensures we remove symlinks from TOP.
955 (cd "$TOP"; PWD= /bin/pwd)
956 else
957 if [ -f $TOPFILE ] ; then
958 # The following circumlocution (repeated below as well) ensures
959 # that we record the true directory name and not one that is
960 # faked up with symlink names.
961 PWD= /bin/pwd
962 else
963 local HERE=$PWD
964 local T=
965 while [ \( ! \( -f $TOPFILE \) \) -a \( "$PWD" != "/" \) ]; do
966 \cd ..
967 T=`PWD= /bin/pwd -P`
968 done
969 \cd "$HERE"
970 if [ -f "$T/$TOPFILE" ]; then
971 echo "$T"
972 fi
973 fi
974 fi
975}
976
Matt Alexanderd9c56562020-05-21 10:49:17 +0000977function croot()
978{
Christopher Ferris55257d22017-03-23 11:08:58 -0700979 local T=$(gettop)
The Android Open Source Projectb6c1cf62008-10-21 07:00:00 -0700980 if [ "$T" ]; then
Marie Janssen32ec50a2016-04-21 16:53:39 -0700981 if [ "$1" ]; then
982 \cd $(gettop)/$1
983 else
984 \cd $(gettop)
985 fi
The Android Open Source Projectb6c1cf62008-10-21 07:00:00 -0700986 else
987 echo "Couldn't locate the top of the tree. Try setting TOP."
988 fi
989}
990
Matt Alexanderd9c56562020-05-21 10:49:17 +0000991function _croot()
992{
Anton Hanssonece9c482019-02-04 18:15:39 +0000993 local T=$(gettop)
994 if [ "$T" ]; then
995 local cur="${COMP_WORDS[COMP_CWORD]}"
996 k=0
997 for c in $(compgen -d ${T}/${cur}); do
998 COMPREPLY[k++]=${c#${T}/}/
999 done
1000 fi
1001}
1002
Matt Alexanderd9c56562020-05-21 10:49:17 +00001003function cproj()
1004{
Colin Cross6cdc5d22017-10-20 11:37:33 -07001005 local TOPFILE=build/make/core/envsetup.mk
Joe Onorato2a5d4d82009-07-30 10:23:21 -07001006 local HERE=$PWD
Christopher Ferris55257d22017-03-23 11:08:58 -07001007 local T=
Joe Onorato2a5d4d82009-07-30 10:23:21 -07001008 while [ \( ! \( -f $TOPFILE \) \) -a \( $PWD != "/" \) ]; do
1009 T=$PWD
1010 if [ -f "$T/Android.mk" ]; then
Ying Wang9cd17642012-12-13 10:52:07 -08001011 \cd $T
Joe Onorato2a5d4d82009-07-30 10:23:21 -07001012 return
1013 fi
Ying Wang9cd17642012-12-13 10:52:07 -08001014 \cd ..
Joe Onorato2a5d4d82009-07-30 10:23:21 -07001015 done
Ying Wang9cd17642012-12-13 10:52:07 -08001016 \cd $HERE
Joe Onorato2a5d4d82009-07-30 10:23:21 -07001017 echo "can't find Android.mk"
1018}
1019
Daniel Sandler47e0a882013-07-30 13:23:52 -04001020# simplified version of ps; output in the form
1021# <pid> <procname>
1022function qpid() {
1023 local prepend=''
1024 local append=''
Matt Alexanderd9c56562020-05-21 10:49:17 +00001025 if [ "$1" = "--exact" ]; then
Daniel Sandler47e0a882013-07-30 13:23:52 -04001026 prepend=' '
1027 append='$'
1028 shift
Matt Alexanderd9c56562020-05-21 10:49:17 +00001029 elif [ "$1" = "--help" -o "$1" = "-h" ]; then
Ying Wang08800fd2016-03-03 20:57:21 -08001030 echo "usage: qpid [[--exact] <process name|pid>"
1031 return 255
1032 fi
Daniel Sandler47e0a882013-07-30 13:23:52 -04001033
1034 local EXE="$1"
Matt Alexanderd9c56562020-05-21 10:49:17 +00001035 if [ "$EXE" ] ; then
Ying Wang08800fd2016-03-03 20:57:21 -08001036 qpid | \grep "$prepend$EXE$append"
1037 else
1038 adb shell ps \
1039 | tr -d '\r' \
1040 | sed -e 1d -e 's/^[^ ]* *\([0-9]*\).* \([^ ]*\)$/\1 \2/'
1041 fi
Daniel Sandler47e0a882013-07-30 13:23:52 -04001042}
1043
Steven Moreland74114f12020-09-10 01:23:32 +00001044# syswrite - disable verity, reboot if needed, and remount image
1045#
1046# Easy way to make system.img/etc writable
1047function syswrite() {
1048 adb wait-for-device && adb root || return 1
1049 if [[ $(adb disable-verity | grep "reboot") ]]; then
1050 echo "rebooting"
1051 adb reboot && adb wait-for-device && adb root || return 1
1052 fi
1053 adb wait-for-device && adb remount || return 1
1054}
1055
Iliyan Malcheve675cfb2014-11-03 17:04:47 -08001056# coredump_setup - enable core dumps globally for any process
Iliyan Malchev248f4d52014-10-28 18:00:42 -07001057# that has the core-file-size limit set correctly
1058#
Iliyan Malchevaf5de972014-11-04 20:57:37 -08001059# NOTE: You must call also coredump_enable for a specific process
Iliyan Malchev248f4d52014-10-28 18:00:42 -07001060# if its core-file-size limit is not set already.
1061# NOTE: Core dumps are written to ramdisk; they will not survive a reboot!
1062
Matt Alexanderd9c56562020-05-21 10:49:17 +00001063function coredump_setup()
1064{
1065 echo "Getting root...";
1066 adb root;
1067 adb wait-for-device;
Iliyan Malchev248f4d52014-10-28 18:00:42 -07001068
Matt Alexanderd9c56562020-05-21 10:49:17 +00001069 echo "Remounting root partition read-write...";
1070 adb shell mount -w -o remount -t rootfs rootfs;
1071 sleep 1;
1072 adb wait-for-device;
1073 adb shell mkdir -p /cores;
1074 adb shell mount -t tmpfs tmpfs /cores;
1075 adb shell chmod 0777 /cores;
Iliyan Malchev248f4d52014-10-28 18:00:42 -07001076
Matt Alexanderd9c56562020-05-21 10:49:17 +00001077 echo "Granting SELinux permission to dump in /cores...";
1078 adb shell restorecon -R /cores;
Iliyan Malchev248f4d52014-10-28 18:00:42 -07001079
Matt Alexanderd9c56562020-05-21 10:49:17 +00001080 echo "Set core pattern.";
1081 adb shell 'echo /cores/core.%p > /proc/sys/kernel/core_pattern';
Iliyan Malchev248f4d52014-10-28 18:00:42 -07001082
Ying Wang08800fd2016-03-03 20:57:21 -08001083 echo "Done."
Iliyan Malchev248f4d52014-10-28 18:00:42 -07001084}
1085
Iliyan Malchevaf5de972014-11-04 20:57:37 -08001086# coredump_enable - enable core dumps for the specified process
Matt Alexanderd9c56562020-05-21 10:49:17 +00001087# $1 = PID of process (e.g., $(pid mediaserver))
Iliyan Malchev248f4d52014-10-28 18:00:42 -07001088#
Iliyan Malchevaf5de972014-11-04 20:57:37 -08001089# NOTE: coredump_setup must have been called as well for a core
Iliyan Malchev248f4d52014-10-28 18:00:42 -07001090# dump to actually be generated.
1091
Matt Alexanderd9c56562020-05-21 10:49:17 +00001092function coredump_enable()
1093{
1094 local PID=$1;
Ying Wang08800fd2016-03-03 20:57:21 -08001095 if [ -z "$PID" ]; then
Matt Alexanderd9c56562020-05-21 10:49:17 +00001096 printf "Expecting a PID!\n";
1097 return;
1098 fi;
1099 echo "Setting core limit for $PID to infinite...";
xi yuaddf4832022-05-26 12:41:21 +00001100 adb shell /system/bin/ulimit -P $PID -c unlimited
Iliyan Malchev248f4d52014-10-28 18:00:42 -07001101}
1102
1103# core - send SIGV and pull the core for process
Matt Alexanderd9c56562020-05-21 10:49:17 +00001104# $1 = PID of process (e.g., $(pid mediaserver))
Iliyan Malchev248f4d52014-10-28 18:00:42 -07001105#
Iliyan Malchevaf5de972014-11-04 20:57:37 -08001106# NOTE: coredump_setup must be called once per boot for core dumps to be
Iliyan Malchev248f4d52014-10-28 18:00:42 -07001107# enabled globally.
1108
Matt Alexanderd9c56562020-05-21 10:49:17 +00001109function core()
1110{
1111 local PID=$1;
Iliyan Malchev248f4d52014-10-28 18:00:42 -07001112
Ying Wang08800fd2016-03-03 20:57:21 -08001113 if [ -z "$PID" ]; then
Matt Alexanderd9c56562020-05-21 10:49:17 +00001114 printf "Expecting a PID!\n";
1115 return;
1116 fi;
Iliyan Malchev248f4d52014-10-28 18:00:42 -07001117
Matt Alexanderd9c56562020-05-21 10:49:17 +00001118 local CORENAME=core.$PID;
1119 local COREPATH=/cores/$CORENAME;
1120 local SIG=SEGV;
Iliyan Malchev248f4d52014-10-28 18:00:42 -07001121
Matt Alexanderd9c56562020-05-21 10:49:17 +00001122 coredump_enable $1;
Iliyan Malchev248f4d52014-10-28 18:00:42 -07001123
Matt Alexanderd9c56562020-05-21 10:49:17 +00001124 local done=0;
Ying Wang08800fd2016-03-03 20:57:21 -08001125 while [ $(adb shell "[ -d /proc/$PID ] && echo -n yes") ]; do
Matt Alexanderd9c56562020-05-21 10:49:17 +00001126 printf "\tSending SIG%s to %d...\n" $SIG $PID;
1127 adb shell kill -$SIG $PID;
1128 sleep 1;
1129 done;
Iliyan Malchev248f4d52014-10-28 18:00:42 -07001130
Matt Alexanderd9c56562020-05-21 10:49:17 +00001131 adb shell "while [ ! -f $COREPATH ] ; do echo waiting for $COREPATH to be generated; sleep 1; done"
1132 echo "Done: core is under $COREPATH on device.";
Iliyan Malchev248f4d52014-10-28 18:00:42 -07001133}
1134
Christopher Tate744ee802009-11-12 15:33:08 -08001135# systemstack - dump the current stack trace of all threads in the system process
1136# to the usual ANR traces file
Matt Alexanderd9c56562020-05-21 10:49:17 +00001137function systemstack()
1138{
Jeff Sharkeyf5824372013-02-19 17:00:46 -08001139 stacks system_server
1140}
1141
Michael Wrightaeed7212014-06-19 19:58:12 -07001142# Read the ELF header from /proc/$PID/exe to determine if the process is
1143# 64-bit.
Matt Alexanderd9c56562020-05-21 10:49:17 +00001144function is64bit()
1145{
Ben Chengfba67bf2014-02-25 10:27:07 -08001146 local PID="$1"
Matt Alexanderd9c56562020-05-21 10:49:17 +00001147 if [ "$PID" ] ; then
1148 if [[ "$(adb shell cat /proc/$PID/exe | xxd -l 1 -s 4 -p)" -eq "02" ]] ; then
Ben Chengfba67bf2014-02-25 10:27:07 -08001149 echo "64"
1150 else
1151 echo ""
1152 fi
1153 else
1154 echo ""
1155 fi
1156}
1157
The Android Open Source Projectb6c1cf62008-10-21 07:00:00 -07001158case `uname -s` in
1159 Darwin)
Matt Alexanderd9c56562020-05-21 10:49:17 +00001160 function sgrep()
1161 {
Taesu Leeea0cecd2020-10-28 11:05:18 +09001162 find -E . -name .repo -prune -o -name .git -prune -o -type f -iregex '.*\.(c|h|cc|cpp|hpp|S|java|kt|xml|sh|mk|aidl|vts|proto)' \
Mike Frysinger5e479732015-09-22 18:13:48 -04001163 -exec grep --color -n "$@" {} +
The Android Open Source Projectb6c1cf62008-10-21 07:00:00 -07001164 }
Matt Alexanderd9c56562020-05-21 10:49:17 +00001165
The Android Open Source Projectb6c1cf62008-10-21 07:00:00 -07001166 ;;
1167 *)
Matt Alexanderd9c56562020-05-21 10:49:17 +00001168 function sgrep()
1169 {
Taesu Leeea0cecd2020-10-28 11:05:18 +09001170 find . -name .repo -prune -o -name .git -prune -o -type f -iregex '.*\.\(c\|h\|cc\|cpp\|hpp\|S\|java\|kt\|xml\|sh\|mk\|aidl\|vts\|proto\)' \
Mike Frysinger5e479732015-09-22 18:13:48 -04001171 -exec grep --color -n "$@" {} +
The Android Open Source Projectb6c1cf62008-10-21 07:00:00 -07001172 }
1173 ;;
1174esac
1175
Matt Alexanderd9c56562020-05-21 10:49:17 +00001176function gettargetarch
1177{
Raghu Gandham8da43102012-07-25 19:57:22 -07001178 get_build_var TARGET_ARCH
1179}
1180
Matt Alexanderd9c56562020-05-21 10:49:17 +00001181function ggrep()
1182{
Mike Frysinger5e479732015-09-22 18:13:48 -04001183 find . -name .repo -prune -o -name .git -prune -o -name out -prune -o -type f -name "*\.gradle" \
1184 -exec grep --color -n "$@" {} +
Jon Boekenoogencbca56f2014-04-07 10:57:38 -07001185}
1186
Matt Alexanderd9c56562020-05-21 10:49:17 +00001187function gogrep()
1188{
Orion Hodson831472d2019-10-25 11:35:15 +01001189 find . -name .repo -prune -o -name .git -prune -o -name out -prune -o -type f -name "*\.go" \
1190 -exec grep --color -n "$@" {} +
1191}
1192
Matt Alexanderd9c56562020-05-21 10:49:17 +00001193function jgrep()
1194{
Mike Frysinger5e479732015-09-22 18:13:48 -04001195 find . -name .repo -prune -o -name .git -prune -o -name out -prune -o -type f -name "*\.java" \
1196 -exec grep --color -n "$@" {} +
The Android Open Source Projectb6c1cf62008-10-21 07:00:00 -07001197}
1198
Alistair Delva176e5342021-02-22 13:31:26 -08001199function rsgrep()
Jeff Vander Stoep1431ab82021-02-02 19:18:26 +01001200{
1201 find . -name .repo -prune -o -name .git -prune -o -name out -prune -o -type f -name "*\.rs" \
1202 -exec grep --color -n "$@" {} +
1203}
1204
Taesu Leeea0cecd2020-10-28 11:05:18 +09001205function ktgrep()
1206{
1207 find . -name .repo -prune -o -name .git -prune -o -name out -prune -o -type f -name "*\.kt" \
1208 -exec grep --color -n "$@" {} +
1209}
1210
Matt Alexanderd9c56562020-05-21 10:49:17 +00001211function cgrep()
1212{
Mike Frysinger5e479732015-09-22 18:13:48 -04001213 find . -name .repo -prune -o -name .git -prune -o -name out -prune -o -type f \( -name '*.c' -o -name '*.cc' -o -name '*.cpp' -o -name '*.h' -o -name '*.hpp' \) \
1214 -exec grep --color -n "$@" {} +
The Android Open Source Projectb6c1cf62008-10-21 07:00:00 -07001215}
1216
Matt Alexanderd9c56562020-05-21 10:49:17 +00001217function resgrep()
1218{
Christopher Ferris55257d22017-03-23 11:08:58 -07001219 local dir
Mike Frysinger5e479732015-09-22 18:13:48 -04001220 for dir in `find . -name .repo -prune -o -name .git -prune -o -name out -prune -o -name res -type d`; do
1221 find $dir -type f -name '*\.xml' -exec grep --color -n "$@" {} +
1222 done
The Android Open Source Projectb6c1cf62008-10-21 07:00:00 -07001223}
1224
Matt Alexanderd9c56562020-05-21 10:49:17 +00001225function mangrep()
1226{
Mike Frysinger5e479732015-09-22 18:13:48 -04001227 find . -name .repo -prune -o -name .git -prune -o -path ./out -prune -o -type f -name 'AndroidManifest.xml' \
1228 -exec grep --color -n "$@" {} +
Jeff Sharkey50b61e92013-03-08 10:20:47 -08001229}
1230
Matt Alexanderd9c56562020-05-21 10:49:17 +00001231function owngrep()
1232{
Jeff Sharkeyf17cddf2019-08-21 12:51:26 -06001233 find . -name .repo -prune -o -name .git -prune -o -path ./out -prune -o -type f -name 'OWNERS' \
1234 -exec grep --color -n "$@" {} +
1235}
1236
Matt Alexanderd9c56562020-05-21 10:49:17 +00001237function sepgrep()
1238{
Mike Frysinger5e479732015-09-22 18:13:48 -04001239 find . -name .repo -prune -o -name .git -prune -o -path ./out -prune -o -name sepolicy -type d \
1240 -exec grep --color -n -r --exclude-dir=\.git "$@" {} +
Alex Klyubinba5fc8e2013-05-06 14:11:48 -07001241}
1242
Matt Alexanderd9c56562020-05-21 10:49:17 +00001243function rcgrep()
1244{
Mike Frysinger5e479732015-09-22 18:13:48 -04001245 find . -name .repo -prune -o -name .git -prune -o -name out -prune -o -type f -name "*\.rc*" \
1246 -exec grep --color -n "$@" {} +
Jeff Sharkeyea0068a2015-02-26 14:13:46 -08001247}
1248
The Android Open Source Projectb6c1cf62008-10-21 07:00:00 -07001249case `uname -s` in
1250 Darwin)
Matt Alexanderd9c56562020-05-21 10:49:17 +00001251 function mgrep()
1252 {
Orion Hodson831472d2019-10-25 11:35:15 +01001253 find -E . -name .repo -prune -o -name .git -prune -o -path ./out -prune -o \( -iregex '.*/(Makefile|Makefile\..*|.*\.make|.*\.mak|.*\.mk|.*\.bp)' -o -regex '(.*/)?(build|soong)/.*[^/]*\.go' \) -type f \
Mike Frysinger5e479732015-09-22 18:13:48 -04001254 -exec grep --color -n "$@" {} +
The Android Open Source Projectb6c1cf62008-10-21 07:00:00 -07001255 }
1256
Matt Alexanderd9c56562020-05-21 10:49:17 +00001257 function treegrep()
1258 {
Taesu Leeea0cecd2020-10-28 11:05:18 +09001259 find -E . -name .repo -prune -o -name .git -prune -o -type f -iregex '.*\.(c|h|cpp|hpp|S|java|kt|xml)' \
Mike Frysinger5e479732015-09-22 18:13:48 -04001260 -exec grep --color -n -i "$@" {} +
The Android Open Source Projectb6c1cf62008-10-21 07:00:00 -07001261 }
1262
1263 ;;
1264 *)
Matt Alexanderd9c56562020-05-21 10:49:17 +00001265 function mgrep()
1266 {
Orion Hodson831472d2019-10-25 11:35:15 +01001267 find . -name .repo -prune -o -name .git -prune -o -path ./out -prune -o \( -regextype posix-egrep -iregex '(.*\/Makefile|.*\/Makefile\..*|.*\.make|.*\.mak|.*\.mk|.*\.bp)' -o -regextype posix-extended -regex '(.*/)?(build|soong)/.*[^/]*\.go' \) -type f \
Mike Frysinger5e479732015-09-22 18:13:48 -04001268 -exec grep --color -n "$@" {} +
The Android Open Source Projectb6c1cf62008-10-21 07:00:00 -07001269 }
1270
Matt Alexanderd9c56562020-05-21 10:49:17 +00001271 function treegrep()
1272 {
Taesu Leeea0cecd2020-10-28 11:05:18 +09001273 find . -name .repo -prune -o -name .git -prune -o -regextype posix-egrep -iregex '.*\.(c|h|cpp|hpp|S|java|kt|xml)' -type f \
Mike Frysinger5e479732015-09-22 18:13:48 -04001274 -exec grep --color -n -i "$@" {} +
The Android Open Source Projectb6c1cf62008-10-21 07:00:00 -07001275 }
1276
1277 ;;
1278esac
1279
Matt Alexanderd9c56562020-05-21 10:49:17 +00001280function getprebuilt
1281{
The Android Open Source Projectb6c1cf62008-10-21 07:00:00 -07001282 get_abs_build_var ANDROID_PREBUILTS
1283}
1284
Matt Alexanderd9c56562020-05-21 10:49:17 +00001285function tracedmdump()
1286{
Christopher Ferris55257d22017-03-23 11:08:58 -07001287 local T=$(gettop)
The Android Open Source Projectb6c1cf62008-10-21 07:00:00 -07001288 if [ ! "$T" ]; then
1289 echo "Couldn't locate the top of the tree. Try setting TOP."
1290 return
1291 fi
The Android Open Source Projectdcc08f02008-12-17 18:03:49 -08001292 local prebuiltdir=$(getprebuilt)
Raghu Gandham8da43102012-07-25 19:57:22 -07001293 local arch=$(gettargetarch)
1294 local KERNEL=$T/prebuilts/qemu-kernel/$arch/vmlinux-qemu
The Android Open Source Projectb6c1cf62008-10-21 07:00:00 -07001295
The Android Open Source Projectdcc08f02008-12-17 18:03:49 -08001296 local TRACE=$1
Matt Alexanderd9c56562020-05-21 10:49:17 +00001297 if [ ! "$TRACE" ] ; then
The Android Open Source Projectb6c1cf62008-10-21 07:00:00 -07001298 echo "usage: tracedmdump tracename"
1299 return
1300 fi
1301
Matt Alexanderd9c56562020-05-21 10:49:17 +00001302 if [ ! -r "$KERNEL" ] ; then
Jack Veenstra60116fc2009-04-09 18:12:34 -07001303 echo "Error: cannot find kernel: '$KERNEL'"
1304 return
1305 fi
1306
The Android Open Source Projectdcc08f02008-12-17 18:03:49 -08001307 local BASETRACE=$(basename $TRACE)
Matt Alexanderd9c56562020-05-21 10:49:17 +00001308 if [ "$BASETRACE" = "$TRACE" ] ; then
The Android Open Source Projectb6c1cf62008-10-21 07:00:00 -07001309 TRACE=$ANDROID_PRODUCT_OUT/traces/$TRACE
1310 fi
1311
1312 echo "post-processing traces..."
1313 rm -f $TRACE/qtrace.dexlist
1314 post_trace $TRACE
1315 if [ $? -ne 0 ]; then
1316 echo "***"
1317 echo "*** Error: malformed trace. Did you remember to exit the emulator?"
1318 echo "***"
1319 return
1320 fi
1321 echo "generating dexlist output..."
1322 /bin/ls $ANDROID_PRODUCT_OUT/system/framework/*.jar $ANDROID_PRODUCT_OUT/system/app/*.apk $ANDROID_PRODUCT_OUT/data/app/*.apk 2>/dev/null | xargs dexlist > $TRACE/qtrace.dexlist
1323 echo "generating dmtrace data..."
1324 q2dm -r $ANDROID_PRODUCT_OUT/symbols $TRACE $KERNEL $TRACE/dmtrace || return
1325 echo "generating html file..."
1326 dmtracedump -h $TRACE/dmtrace >| $TRACE/dmtrace.html || return
1327 echo "done, see $TRACE/dmtrace.html for details"
1328 echo "or run:"
1329 echo " traceview $TRACE/dmtrace"
1330}
1331
The Android Open Source Projectdcc08f02008-12-17 18:03:49 -08001332# communicate with a running device or emulator, set up necessary state,
1333# and run the hat command.
Matt Alexanderd9c56562020-05-21 10:49:17 +00001334function runhat()
1335{
The Android Open Source Projectdcc08f02008-12-17 18:03:49 -08001336 # process standard adb options
1337 local adbTarget=""
Matt Alexanderd9c56562020-05-21 10:49:17 +00001338 if [ "$1" = "-d" -o "$1" = "-e" ]; then
The Android Open Source Projectdcc08f02008-12-17 18:03:49 -08001339 adbTarget=$1
1340 shift 1
Matt Alexanderd9c56562020-05-21 10:49:17 +00001341 elif [ "$1" = "-s" ]; then
The Android Open Source Projectdcc08f02008-12-17 18:03:49 -08001342 adbTarget="$1 $2"
1343 shift 2
1344 fi
1345 local adbOptions=${adbTarget}
Matt Alexanderd9c56562020-05-21 10:49:17 +00001346 #echo adbOptions = ${adbOptions}
The Android Open Source Projectdcc08f02008-12-17 18:03:49 -08001347
1348 # runhat options
1349 local targetPid=$1
The Android Open Source Projectb6c1cf62008-10-21 07:00:00 -07001350
Matt Alexanderd9c56562020-05-21 10:49:17 +00001351 if [ "$targetPid" = "" ]; then
Andy McFaddenb6289852010-07-12 08:00:19 -07001352 echo "Usage: runhat [ -d | -e | -s serial ] target-pid"
The Android Open Source Projectb6c1cf62008-10-21 07:00:00 -07001353 return
1354 fi
1355
The Android Open Source Projectdcc08f02008-12-17 18:03:49 -08001356 # confirm hat is available
1357 if [ -z $(which hat) ]; then
1358 echo "hat is not available in this configuration."
1359 return
1360 fi
1361
Andy McFaddenb6289852010-07-12 08:00:19 -07001362 # issue "am" command to cause the hprof dump
Nick Kralevich9948b1e2014-07-18 15:45:38 -07001363 local devFile=/data/local/tmp/hprof-$targetPid
The Android Open Source Projectb6c1cf62008-10-21 07:00:00 -07001364 echo "Poking $targetPid and waiting for data..."
Dianne Hackborn6b9549f2012-09-26 15:00:59 -07001365 echo "Storing data at $devFile"
Andy McFaddenb6289852010-07-12 08:00:19 -07001366 adb ${adbOptions} shell am dumpheap $targetPid $devFile
The Android Open Source Project88b60792009-03-03 19:28:42 -08001367 echo "Press enter when logcat shows \"hprof: heap dump completed\""
The Android Open Source Projectb6c1cf62008-10-21 07:00:00 -07001368 echo -n "> "
1369 read
1370
The Android Open Source Project88b60792009-03-03 19:28:42 -08001371 local localFile=/tmp/$$-hprof
The Android Open Source Projectb6c1cf62008-10-21 07:00:00 -07001372
The Android Open Source Project88b60792009-03-03 19:28:42 -08001373 echo "Retrieving file $devFile..."
1374 adb ${adbOptions} pull $devFile $localFile
The Android Open Source Projectb6c1cf62008-10-21 07:00:00 -07001375
The Android Open Source Project88b60792009-03-03 19:28:42 -08001376 adb ${adbOptions} shell rm $devFile
The Android Open Source Projectb6c1cf62008-10-21 07:00:00 -07001377
The Android Open Source Project88b60792009-03-03 19:28:42 -08001378 echo "Running hat on $localFile"
The Android Open Source Projectb6c1cf62008-10-21 07:00:00 -07001379 echo "View the output by pointing your browser at http://localhost:7000/"
1380 echo ""
Dianne Hackborn6e4e1bb2011-11-10 15:19:51 -08001381 hat -JXmx512m $localFile
The Android Open Source Projectb6c1cf62008-10-21 07:00:00 -07001382}
1383
Matt Alexanderd9c56562020-05-21 10:49:17 +00001384function getbugreports()
1385{
The Android Open Source Projectdcc08f02008-12-17 18:03:49 -08001386 local reports=(`adb shell ls /sdcard/bugreports | tr -d '\r'`)
The Android Open Source Projectb6c1cf62008-10-21 07:00:00 -07001387
1388 if [ ! "$reports" ]; then
1389 echo "Could not locate any bugreports."
1390 return
1391 fi
1392
The Android Open Source Projectdcc08f02008-12-17 18:03:49 -08001393 local report
1394 for report in ${reports[@]}
The Android Open Source Projectb6c1cf62008-10-21 07:00:00 -07001395 do
The Android Open Source Projectdcc08f02008-12-17 18:03:49 -08001396 echo "/sdcard/bugreports/${report}"
1397 adb pull /sdcard/bugreports/${report} ${report}
1398 gunzip ${report}
The Android Open Source Projectb6c1cf62008-10-21 07:00:00 -07001399 done
1400}
1401
Matt Alexanderd9c56562020-05-21 10:49:17 +00001402function getsdcardpath()
1403{
Victoria Lease1b296b42012-08-21 15:44:06 -07001404 adb ${adbOptions} shell echo -n \$\{EXTERNAL_STORAGE\}
1405}
1406
Matt Alexanderd9c56562020-05-21 10:49:17 +00001407function getscreenshotpath()
1408{
Victoria Lease1b296b42012-08-21 15:44:06 -07001409 echo "$(getsdcardpath)/Pictures/Screenshots"
1410}
1411
Matt Alexanderd9c56562020-05-21 10:49:17 +00001412function getlastscreenshot()
1413{
Victoria Lease1b296b42012-08-21 15:44:06 -07001414 local screenshot_path=$(getscreenshotpath)
1415 local screenshot=`adb ${adbOptions} ls ${screenshot_path} | grep Screenshot_[0-9-]*.*\.png | sort -rk 3 | cut -d " " -f 4 | head -n 1`
Matt Alexanderd9c56562020-05-21 10:49:17 +00001416 if [ "$screenshot" = "" ]; then
Victoria Lease1b296b42012-08-21 15:44:06 -07001417 echo "No screenshots found."
1418 return
1419 fi
1420 echo "${screenshot}"
1421 adb ${adbOptions} pull ${screenshot_path}/${screenshot}
1422}
1423
Matt Alexanderd9c56562020-05-21 10:49:17 +00001424function startviewserver()
1425{
The Android Open Source Projectdcc08f02008-12-17 18:03:49 -08001426 local port=4939
The Android Open Source Projectb6c1cf62008-10-21 07:00:00 -07001427 if [ $# -gt 0 ]; then
1428 port=$1
1429 fi
1430 adb shell service call window 1 i32 $port
1431}
1432
Matt Alexanderd9c56562020-05-21 10:49:17 +00001433function stopviewserver()
1434{
The Android Open Source Projectb6c1cf62008-10-21 07:00:00 -07001435 adb shell service call window 2
1436}
1437
Matt Alexanderd9c56562020-05-21 10:49:17 +00001438function isviewserverstarted()
1439{
The Android Open Source Projectb6c1cf62008-10-21 07:00:00 -07001440 adb shell service call window 3
1441}
1442
Matt Alexanderd9c56562020-05-21 10:49:17 +00001443function key_home()
1444{
Romain Guyb84049a2010-10-04 16:56:11 -07001445 adb shell input keyevent 3
1446}
1447
Matt Alexanderd9c56562020-05-21 10:49:17 +00001448function key_back()
1449{
Romain Guyb84049a2010-10-04 16:56:11 -07001450 adb shell input keyevent 4
1451}
1452
Matt Alexanderd9c56562020-05-21 10:49:17 +00001453function key_menu()
1454{
Romain Guyb84049a2010-10-04 16:56:11 -07001455 adb shell input keyevent 82
1456}
1457
Matt Alexanderd9c56562020-05-21 10:49:17 +00001458function smoketest()
1459{
The Android Open Source Projectb6c1cf62008-10-21 07:00:00 -07001460 if [ ! "$ANDROID_PRODUCT_OUT" ]; then
1461 echo "Couldn't locate output files. Try running 'lunch' first." >&2
1462 return
1463 fi
Christopher Ferris55257d22017-03-23 11:08:58 -07001464 local T=$(gettop)
The Android Open Source Projectb6c1cf62008-10-21 07:00:00 -07001465 if [ ! "$T" ]; then
1466 echo "Couldn't locate the top of the tree. Try setting TOP." >&2
1467 return
1468 fi
1469
Ying Wang9cd17642012-12-13 10:52:07 -08001470 (\cd "$T" && mmm tests/SmokeTest) &&
The Android Open Source Projectb6c1cf62008-10-21 07:00:00 -07001471 adb uninstall com.android.smoketest > /dev/null &&
1472 adb uninstall com.android.smoketest.tests > /dev/null &&
1473 adb install $ANDROID_PRODUCT_OUT/data/app/SmokeTestApp.apk &&
1474 adb install $ANDROID_PRODUCT_OUT/data/app/SmokeTest.apk &&
1475 adb shell am instrument -w com.android.smoketest.tests/android.test.InstrumentationTestRunner
1476}
1477
The Android Open Source Projectdcc08f02008-12-17 18:03:49 -08001478# simple shortcut to the runtest command
Matt Alexanderd9c56562020-05-21 10:49:17 +00001479function runtest()
1480{
Christopher Ferris55257d22017-03-23 11:08:58 -07001481 local T=$(gettop)
The Android Open Source Projectdcc08f02008-12-17 18:03:49 -08001482 if [ ! "$T" ]; then
1483 echo "Couldn't locate the top of the tree. Try setting TOP." >&2
1484 return
1485 fi
Brett Chabot3fb149d2009-10-21 20:05:26 -07001486 ("$T"/development/testrunner/runtest.py $@)
Brett Chabot762748c2009-03-27 10:25:11 -07001487}
1488
The Android Open Source Project88b60792009-03-03 19:28:42 -08001489function godir () {
1490 if [[ -z "$1" ]]; then
1491 echo "Usage: godir <regex>"
1492 return
1493 fi
Christopher Ferris55257d22017-03-23 11:08:58 -07001494 local T=$(gettop)
1495 local FILELIST
Matt Alexanderd9c56562020-05-21 10:49:17 +00001496 if [ ! "$OUT_DIR" = "" ]; then
Brian Carlstromf2257422015-09-30 20:28:54 -07001497 mkdir -p $OUT_DIR
1498 FILELIST=$OUT_DIR/filelist
1499 else
1500 FILELIST=$T/filelist
1501 fi
1502 if [[ ! -f $FILELIST ]]; then
The Android Open Source Project88b60792009-03-03 19:28:42 -08001503 echo -n "Creating index..."
Brian Carlstromf2257422015-09-30 20:28:54 -07001504 (\cd $T; find . -wholename ./out -prune -o -wholename ./.repo -prune -o -type f > $FILELIST)
The Android Open Source Project88b60792009-03-03 19:28:42 -08001505 echo " Done"
1506 echo ""
1507 fi
1508 local lines
Brian Carlstromf2257422015-09-30 20:28:54 -07001509 lines=($(\grep "$1" $FILELIST | sed -e 's/\/[^/]*$//' | sort | uniq))
Matt Alexanderd9c56562020-05-21 10:49:17 +00001510 if [[ ${#lines[@]} = 0 ]]; then
The Android Open Source Project88b60792009-03-03 19:28:42 -08001511 echo "Not found"
1512 return
1513 fi
1514 local pathname
1515 local choice
1516 if [[ ${#lines[@]} > 1 ]]; then
1517 while [[ -z "$pathname" ]]; do
1518 local index=1
1519 local line
1520 for line in ${lines[@]}; do
1521 printf "%6s %s\n" "[$index]" $line
Doug Zongker29034982011-04-22 08:16:56 -07001522 index=$(($index + 1))
The Android Open Source Project88b60792009-03-03 19:28:42 -08001523 done
1524 echo
1525 echo -n "Select one: "
1526 unset choice
1527 read choice
1528 if [[ $choice -gt ${#lines[@]} || $choice -lt 1 ]]; then
1529 echo "Invalid choice"
1530 continue
1531 fi
Guillaume Chelfice000fd2019-10-03 12:02:46 +02001532 pathname=${lines[@]:$(($choice-1)):1}
The Android Open Source Project88b60792009-03-03 19:28:42 -08001533 done
1534 else
Guillaume Chelfice000fd2019-10-03 12:02:46 +02001535 pathname=${lines[@]:0:1}
The Android Open Source Project88b60792009-03-03 19:28:42 -08001536 fi
Ying Wang9cd17642012-12-13 10:52:07 -08001537 \cd $T/$pathname
The Android Open Source Project88b60792009-03-03 19:28:42 -08001538}
1539
Steven Moreland62054a42018-12-06 10:11:40 -08001540# Update module-info.json in out.
1541function refreshmod() {
1542 if [ ! "$ANDROID_PRODUCT_OUT" ]; then
1543 echo "No ANDROID_PRODUCT_OUT. Try running 'lunch' first." >&2
1544 return 1
1545 fi
1546
1547 echo "Refreshing modules (building module-info.json). Log at $ANDROID_PRODUCT_OUT/module-info.json.build.log." >&2
1548
1549 # for the output of the next command
1550 mkdir -p $ANDROID_PRODUCT_OUT || return 1
1551
1552 # Note, can't use absolute path because of the way make works.
Alessandro Astonec8771be2020-05-10 11:27:57 +02001553 m $(get_build_var PRODUCT_OUT)/module-info.json \
Steven Moreland62054a42018-12-06 10:11:40 -08001554 > $ANDROID_PRODUCT_OUT/module-info.json.build.log 2>&1
1555}
1556
Cole Faust3e192382021-10-25 13:29:15 -07001557# Verifies that module-info.txt exists, returning nonzero if it doesn't.
Cole Faust24c36db2021-01-23 02:39:37 +00001558function verifymodinfo() {
Steven Moreland62054a42018-12-06 10:11:40 -08001559 if [ ! "$ANDROID_PRODUCT_OUT" ]; then
Joe Onorato0bac4fe2021-04-07 08:51:28 -07001560 if [ "$QUIET_VERIFYMODINFO" != "true" ] ; then
1561 echo "No ANDROID_PRODUCT_OUT. Try running 'lunch' first." >&2
1562 fi
Steven Moreland62054a42018-12-06 10:11:40 -08001563 return 1
1564 fi
1565
1566 if [ ! -f "$ANDROID_PRODUCT_OUT/module-info.json" ]; then
Joe Onorato0bac4fe2021-04-07 08:51:28 -07001567 if [ "$QUIET_VERIFYMODINFO" != "true" ] ; then
Cole Faust3e192382021-10-25 13:29:15 -07001568 echo "Could not find module-info.json. Please run 'refreshmod' first." >&2
Joe Onorato0bac4fe2021-04-07 08:51:28 -07001569 fi
1570 return 1
Steven Moreland62054a42018-12-06 10:11:40 -08001571 fi
Cole Faust24c36db2021-01-23 02:39:37 +00001572}
1573
1574# List all modules for the current device, as cached in module-info.json. If any build change is
1575# made and it should be reflected in the output, you should run 'refreshmod' first.
1576function allmod() {
1577 verifymodinfo || return 1
Steven Moreland62054a42018-12-06 10:11:40 -08001578
Joe Onorato4acbe3b2021-04-29 15:31:42 -07001579 python3 -c "import json; print('\n'.join(sorted(json.load(open('$ANDROID_PRODUCT_OUT/module-info.json')).keys())))"
Steven Moreland62054a42018-12-06 10:11:40 -08001580}
1581
Joe Onorato2c1aa472021-02-25 16:42:39 -08001582# Get the path of a specific module in the android tree, as cached in module-info.json.
1583# If any build change is made, and it should be reflected in the output, you should run
1584# 'refreshmod' first. Note: This is the inverse of dirmods.
Rett Berg78d1c932019-01-24 14:34:23 -08001585function pathmod() {
Steven Moreland62054a42018-12-06 10:11:40 -08001586 if [[ $# -ne 1 ]]; then
Rett Berg78d1c932019-01-24 14:34:23 -08001587 echo "usage: pathmod <module>" >&2
Steven Moreland62054a42018-12-06 10:11:40 -08001588 return 1
1589 fi
1590
Cole Faust24c36db2021-01-23 02:39:37 +00001591 verifymodinfo || return 1
Steven Moreland62054a42018-12-06 10:11:40 -08001592
Joe Onorato4acbe3b2021-04-29 15:31:42 -07001593 local relpath=$(python3 -c "import json, os
Steven Moreland62054a42018-12-06 10:11:40 -08001594module = '$1'
1595module_info = json.load(open('$ANDROID_PRODUCT_OUT/module-info.json'))
1596if module not in module_info:
1597 exit(1)
LuK1337b6a78192020-01-12 03:12:17 +01001598print(module_info[module]['path'][0])" 2>/dev/null)
Steven Moreland62054a42018-12-06 10:11:40 -08001599
1600 if [ -z "$relpath" ]; then
1601 echo "Could not find module '$1' (try 'refreshmod' if there have been build changes?)." >&2
1602 return 1
1603 else
Rett Berg78d1c932019-01-24 14:34:23 -08001604 echo "$ANDROID_BUILD_TOP/$relpath"
Steven Moreland62054a42018-12-06 10:11:40 -08001605 fi
1606}
1607
Joe Onorato2c1aa472021-02-25 16:42:39 -08001608# Get the path of a specific module in the android tree, as cached in module-info.json.
1609# If any build change is made, and it should be reflected in the output, you should run
1610# 'refreshmod' first. Note: This is the inverse of pathmod.
1611function dirmods() {
1612 if [[ $# -ne 1 ]]; then
1613 echo "usage: dirmods <path>" >&2
1614 return 1
1615 fi
1616
1617 verifymodinfo || return 1
1618
Joe Onorato4acbe3b2021-04-29 15:31:42 -07001619 python3 -c "import json, os
Joe Onorato2c1aa472021-02-25 16:42:39 -08001620dir = '$1'
1621while dir.endswith('/'):
1622 dir = dir[:-1]
1623prefix = dir + '/'
1624module_info = json.load(open('$ANDROID_PRODUCT_OUT/module-info.json'))
1625results = set()
1626for m in module_info.values():
1627 for path in m.get(u'path', []):
1628 if path == dir or path.startswith(prefix):
1629 name = m.get(u'module_name')
1630 if name:
1631 results.add(name)
1632for name in sorted(results):
1633 print(name)
1634"
1635}
1636
1637
Rett Berg78d1c932019-01-24 14:34:23 -08001638# Go to a specific module in the android tree, as cached in module-info.json. If any build change
1639# is made, and it should be reflected in the output, you should run 'refreshmod' first.
1640function gomod() {
1641 if [[ $# -ne 1 ]]; then
1642 echo "usage: gomod <module>" >&2
1643 return 1
1644 fi
1645
1646 local path="$(pathmod $@)"
1647 if [ -z "$path" ]; then
1648 return 1
1649 fi
1650 cd $path
1651}
1652
Cole Faust24c36db2021-01-23 02:39:37 +00001653# Gets the list of a module's installed outputs, as cached in module-info.json.
1654# If any build change is made, and it should be reflected in the output, you should run 'refreshmod' first.
1655function outmod() {
1656 if [[ $# -ne 1 ]]; then
1657 echo "usage: outmod <module>" >&2
1658 return 1
1659 fi
1660
1661 verifymodinfo || return 1
1662
1663 local relpath
Joe Onorato4acbe3b2021-04-29 15:31:42 -07001664 relpath=$(python3 -c "import json, os
Cole Faust24c36db2021-01-23 02:39:37 +00001665module = '$1'
1666module_info = json.load(open('$ANDROID_PRODUCT_OUT/module-info.json'))
1667if module not in module_info:
1668 exit(1)
1669for output in module_info[module]['installed']:
1670 print(os.path.join('$ANDROID_BUILD_TOP', output))" 2>/dev/null)
1671
1672 if [ $? -ne 0 ]; then
1673 echo "Could not find module '$1' (try 'refreshmod' if there have been build changes?)" >&2
1674 return 1
1675 elif [ ! -z "$relpath" ]; then
1676 echo "$relpath"
1677 fi
1678}
1679
1680# adb install a module's apk, as cached in module-info.json. If any build change
1681# is made, and it should be reflected in the output, you should run 'refreshmod' first.
1682# Usage: installmod [adb install arguments] <module>
1683# For example: installmod -r Dialer -> adb install -r /path/to/Dialer.apk
1684function installmod() {
1685 if [[ $# -eq 0 ]]; then
1686 echo "usage: installmod [adb install arguments] <module>" >&2
Cole Faust3e192382021-10-25 13:29:15 -07001687 echo "" >&2
1688 echo "Only flags to be passed after the \"install\" in adb install are supported," >&2
1689 echo "with the exception of -s. If -s is passed it will be placed before the \"install\"." >&2
1690 echo "-s must be the first flag passed if it exists." >&2
Cole Faust24c36db2021-01-23 02:39:37 +00001691 return 1
1692 fi
1693
1694 local _path
1695 _path=$(outmod ${@:$#:1})
1696 if [ $? -ne 0 ]; then
1697 return 1
1698 fi
1699
1700 _path=$(echo "$_path" | grep -E \\.apk$ | head -n 1)
1701 if [ -z "$_path" ]; then
1702 echo "Module '$1' does not produce a file ending with .apk (try 'refreshmod' if there have been build changes?)" >&2
1703 return 1
1704 fi
Cole Faust3e192382021-10-25 13:29:15 -07001705 local serial_device=""
1706 if [[ "$1" == "-s" ]]; then
1707 if [[ $# -le 2 ]]; then
1708 echo "-s requires an argument" >&2
1709 return 1
1710 fi
1711 serial_device="-s $2"
1712 shift 2
1713 fi
Cole Faust24c36db2021-01-23 02:39:37 +00001714 local length=$(( $# - 1 ))
Cole Faust3e192382021-10-25 13:29:15 -07001715 echo adb $serial_device install ${@:1:$length} $_path
1716 adb $serial_device install ${@:1:$length} $_path
Cole Faust24c36db2021-01-23 02:39:37 +00001717}
1718
dimitry73b84812018-12-11 18:06:00 +01001719function _complete_android_module_names() {
Steven Moreland62054a42018-12-06 10:11:40 -08001720 local word=${COMP_WORDS[COMP_CWORD]}
Joe Onorato0bac4fe2021-04-07 08:51:28 -07001721 COMPREPLY=( $(QUIET_VERIFYMODINFO=true allmod | grep -E "^$word") )
Steven Moreland62054a42018-12-06 10:11:40 -08001722}
1723
Alex Rayf0d08eb2013-03-08 15:15:06 -08001724# Print colored exit condition
1725function pez {
Michael Wrighteb733842013-03-08 17:34:02 -08001726 "$@"
1727 local retval=$?
Matt Alexanderd9c56562020-05-21 10:49:17 +00001728 if [ $retval -ne 0 ]
1729 then
Jacky Cao89483b82015-05-15 22:12:53 +08001730 echo $'\E'"[0;31mFAILURE\e[00m"
Michael Wrighteb733842013-03-08 17:34:02 -08001731 else
Jacky Cao89483b82015-05-15 22:12:53 +08001732 echo $'\E'"[0;32mSUCCESS\e[00m"
Michael Wrighteb733842013-03-08 17:34:02 -08001733 fi
1734 return $retval
Alex Rayf0d08eb2013-03-08 15:15:06 -08001735}
1736
Matt Alexanderd9c56562020-05-21 10:49:17 +00001737function get_make_command()
1738{
Dan Willemsend41ec5a2017-07-12 16:14:50 -07001739 # If we're in the top of an Android tree, use soong_ui.bash instead of make
1740 if [ -f build/soong/soong_ui.bash ]; then
Dan Willemsene9842242017-07-28 13:00:13 -07001741 # Always use the real make if -C is passed in
1742 for arg in "$@"; do
1743 if [[ $arg == -C* ]]; then
1744 echo command make
1745 return
1746 fi
1747 done
Dan Willemsend41ec5a2017-07-12 16:14:50 -07001748 echo build/soong/soong_ui.bash --make-mode
1749 else
1750 echo command make
1751 fi
Ying Wanged21d4c2014-08-24 22:14:19 -07001752}
1753
Matt Alexanderd9c56562020-05-21 10:49:17 +00001754function _wrap_build()
1755{
Sasha Smundak9f27cc02019-01-31 13:25:31 -08001756 if [[ "${ANDROID_QUIET_BUILD:-}" == true ]]; then
1757 "$@"
1758 return $?
1759 fi
Ed Heylcc6be0a2014-06-18 14:55:58 -07001760 local start_time=$(date +"%s")
Dan Willemsend41ec5a2017-07-12 16:14:50 -07001761 "$@"
Ed Heylcc6be0a2014-06-18 14:55:58 -07001762 local ret=$?
1763 local end_time=$(date +"%s")
1764 local tdiff=$(($end_time-$start_time))
1765 local hours=$(($tdiff / 3600 ))
1766 local mins=$((($tdiff % 3600) / 60))
1767 local secs=$(($tdiff % 60))
Greg Hackmannd95c7f72014-06-23 14:05:06 -07001768 local ncolors=$(tput colors 2>/dev/null)
1769 if [ -n "$ncolors" ] && [ $ncolors -ge 8 ]; then
Jacky Cao89483b82015-05-15 22:12:53 +08001770 color_failed=$'\E'"[0;31m"
1771 color_success=$'\E'"[0;32m"
Kousik Kumar09af2542021-08-19 16:13:32 -04001772 color_warning=$'\E'"[0;33m"
Jacky Cao89483b82015-05-15 22:12:53 +08001773 color_reset=$'\E'"[00m"
Greg Hackmannd95c7f72014-06-23 14:05:06 -07001774 else
1775 color_failed=""
1776 color_success=""
1777 color_reset=""
1778 fi
Kousik Kumar09af2542021-08-19 16:13:32 -04001779
1780 if [[ "x${USE_RBE}" == "x" && $mins -gt 15 && "${ANDROID_BUILD_ENVIRONMENT_CONFIG}" == "googler" ]]; then
1781 echo
1782 echo "${color_warning}Start using RBE (http://go/build-fast) to get faster builds!${color_reset}"
1783 fi
1784
Ed Heylcc6be0a2014-06-18 14:55:58 -07001785 echo
Matt Alexanderd9c56562020-05-21 10:49:17 +00001786 if [ $ret -eq 0 ] ; then
Dan Willemsend41ec5a2017-07-12 16:14:50 -07001787 echo -n "${color_success}#### build completed successfully "
Ed Heylcc6be0a2014-06-18 14:55:58 -07001788 else
Dan Willemsend41ec5a2017-07-12 16:14:50 -07001789 echo -n "${color_failed}#### failed to build some targets "
Ed Heylcc6be0a2014-06-18 14:55:58 -07001790 fi
Matt Alexanderd9c56562020-05-21 10:49:17 +00001791 if [ $hours -gt 0 ] ; then
Ed Heylcc6be0a2014-06-18 14:55:58 -07001792 printf "(%02g:%02g:%02g (hh:mm:ss))" $hours $mins $secs
Matt Alexanderd9c56562020-05-21 10:49:17 +00001793 elif [ $mins -gt 0 ] ; then
Ed Heylcc6be0a2014-06-18 14:55:58 -07001794 printf "(%02g:%02g (mm:ss))" $mins $secs
Matt Alexanderd9c56562020-05-21 10:49:17 +00001795 elif [ $secs -gt 0 ] ; then
Ed Heylcc6be0a2014-06-18 14:55:58 -07001796 printf "(%s seconds)" $secs
1797 fi
Jacky Cao89483b82015-05-15 22:12:53 +08001798 echo " ####${color_reset}"
Ed Heylcc6be0a2014-06-18 14:55:58 -07001799 echo
1800 return $ret
1801}
1802
Patrice Arrudafa7204b2019-06-20 23:40:33 +00001803function _trigger_build()
1804(
1805 local -r bc="$1"; shift
1806 if T="$(gettop)"; then
1807 _wrap_build "$T/build/soong/soong_ui.bash" --build-mode --${bc} --dir="$(pwd)" "$@"
1808 else
Jingwen Chend728ee12021-05-18 06:02:53 +00001809 >&2 echo "Couldn't locate the top of the tree. Try setting TOP."
1810 return 1
Patrice Arrudafa7204b2019-06-20 23:40:33 +00001811 fi
1812)
1813
Jingwen Chen69f9ed12021-06-16 09:44:26 +00001814# Convenience entry point (like m) to use Bazel in AOSP.
Jingwen Chend728ee12021-05-18 06:02:53 +00001815function b()
1816(
1817 # Generate BUILD, bzl files into the synthetic Bazel workspace (out/soong/workspace).
Sam Delmerico9d67a902022-04-11 12:25:18 +00001818 _trigger_build "all-modules" bp2build USE_BAZEL_ANALYSIS= || return 1
Jingwen Chend728ee12021-05-18 06:02:53 +00001819 # Then, run Bazel using the synthetic workspace as the --package_path.
Sam Delmerico9d67a902022-04-11 12:25:18 +00001820 if [[ -z "$@" ]]; then
Jingwen Chen69f9ed12021-06-16 09:44:26 +00001821 # If there are no args, show help.
Jingwen Chenbfa114d2021-06-17 05:42:43 +00001822 bazel help
Jingwen Chen69f9ed12021-06-16 09:44:26 +00001823 else
1824 # Else, always run with the bp2build configuration, which sets Bazel's package path to the synthetic workspace.
Sam Delmerico9d67a902022-04-11 12:25:18 +00001825 bazel "$@" --config=bp2build
Jingwen Chen69f9ed12021-06-16 09:44:26 +00001826 fi
Jingwen Chend728ee12021-05-18 06:02:53 +00001827)
1828
Patrice Arrudafa7204b2019-06-20 23:40:33 +00001829function m()
1830(
1831 _trigger_build "all-modules" "$@"
1832)
1833
1834function mm()
1835(
1836 _trigger_build "modules-in-a-dir-no-deps" "$@"
1837)
1838
1839function mmm()
1840(
1841 _trigger_build "modules-in-dirs-no-deps" "$@"
1842)
1843
1844function mma()
1845(
1846 _trigger_build "modules-in-a-dir" "$@"
1847)
1848
1849function mmma()
1850(
1851 _trigger_build "modules-in-dirs" "$@"
1852)
1853
Matt Alexanderd9c56562020-05-21 10:49:17 +00001854function make()
1855{
Dan Willemsene9842242017-07-28 13:00:13 -07001856 _wrap_build $(get_make_command "$@") "$@"
Dan Willemsend41ec5a2017-07-12 16:14:50 -07001857}
1858
Joe Onorato7cf6f972022-05-11 21:39:57 -07001859function _multitree_lunch_error()
1860{
1861 >&2 echo "Couldn't locate the top of the tree. Please run \'source build/envsetup.sh\' and multitree_lunch from the root of your workspace."
1862}
1863
1864function multitree_build()
1865{
1866 if T="$(multitree_gettop)"; then
1867 "$T/build/build/orchestrator/core/orchestrator.py" "$@"
1868 else
1869 _multitree_lunch_error
1870 return 1
1871 fi
1872}
1873
Matt Alexanderd9c56562020-05-21 10:49:17 +00001874function provision()
1875{
David Zeuthen1b126ff2015-09-30 17:10:48 -04001876 if [ ! "$ANDROID_PRODUCT_OUT" ]; then
1877 echo "Couldn't locate output files. Try running 'lunch' first." >&2
1878 return 1
1879 fi
1880 if [ ! -e "$ANDROID_PRODUCT_OUT/provision-device" ]; then
1881 echo "There is no provisioning script for the device." >&2
1882 return 1
1883 fi
1884
1885 # Check if user really wants to do this.
Matt Alexanderd9c56562020-05-21 10:49:17 +00001886 if [ "$1" = "--no-confirmation" ]; then
David Zeuthen1b126ff2015-09-30 17:10:48 -04001887 shift 1
1888 else
1889 echo "This action will reflash your device."
1890 echo ""
1891 echo "ALL DATA ON THE DEVICE WILL BE IRREVOCABLY ERASED."
1892 echo ""
Marie Janssen4afc2c02015-11-10 10:41:15 -08001893 echo -n "Are you sure you want to do this (yes/no)? "
1894 read
Matt Alexanderd9c56562020-05-21 10:49:17 +00001895 if [[ "${REPLY}" != "yes" ]] ; then
David Zeuthen1b126ff2015-09-30 17:10:48 -04001896 echo "Not taking any action. Exiting." >&2
1897 return 1
1898 fi
1899 fi
1900 "$ANDROID_PRODUCT_OUT/provision-device" "$@"
1901}
1902
Jim Tanga881a252018-06-19 16:34:41 +08001903# Zsh needs bashcompinit called to support bash-style completion.
Patrik Fimmldf248e62018-10-15 18:15:12 +02001904function enable_zsh_completion() {
1905 # Don't override user's options if bash-style completion is already enabled.
1906 if ! declare -f complete >/dev/null; then
1907 autoload -U compinit && compinit
1908 autoload -U bashcompinit && bashcompinit
1909 fi
Jim Tanga881a252018-06-19 16:34:41 +08001910}
1911
1912function validate_current_shell() {
1913 local current_sh="$(ps -o command -p $$)"
1914 case "$current_sh" in
Raphael Moll70a86b02011-06-20 16:03:14 -07001915 *bash*)
Jim Tanga881a252018-06-19 16:34:41 +08001916 function check_type() { type -t "$1"; }
Raphael Moll70a86b02011-06-20 16:03:14 -07001917 ;;
Jim Tanga881a252018-06-19 16:34:41 +08001918 *zsh*)
1919 function check_type() { type "$1"; }
Matt Alexanderd9c56562020-05-21 10:49:17 +00001920 enable_zsh_completion ;;
Raphael Moll70a86b02011-06-20 16:03:14 -07001921 *)
Jim Tanga881a252018-06-19 16:34:41 +08001922 echo -e "WARNING: Only bash and zsh are supported.\nUse of other shell would lead to erroneous results."
Raphael Moll70a86b02011-06-20 16:03:14 -07001923 ;;
1924 esac
Jim Tanga881a252018-06-19 16:34:41 +08001925}
The Android Open Source Projectdcc08f02008-12-17 18:03:49 -08001926
1927# Execute the contents of any vendorsetup.sh files we can find.
Dan Willemsend855a722019-02-12 15:52:36 -08001928# Unless we find an allowed-vendorsetup_sh-files file, in which case we'll only
1929# load those.
1930#
1931# This allows loading only approved vendorsetup.sh files
Jim Tanga881a252018-06-19 16:34:41 +08001932function source_vendorsetup() {
Jim Tangc4dba1d2019-07-25 16:54:27 +08001933 unset VENDOR_PYTHONPATH
Patrice Arrudaaa4b8242020-10-12 21:29:14 +00001934 local T="$(gettop)"
Dan Willemsend855a722019-02-12 15:52:36 -08001935 allowed=
Patrice Arrudaaa4b8242020-10-12 21:29:14 +00001936 for f in $(cd "$T" && find -L device vendor product -maxdepth 4 -name 'allowed-vendorsetup_sh-files' 2>/dev/null | sort); do
Dan Willemsend855a722019-02-12 15:52:36 -08001937 if [ -n "$allowed" ]; then
1938 echo "More than one 'allowed_vendorsetup_sh-files' file found, not including any vendorsetup.sh files:"
1939 echo " $allowed"
1940 echo " $f"
1941 return
1942 fi
Patrice Arrudaaa4b8242020-10-12 21:29:14 +00001943 allowed="$T/$f"
Dan Willemsend855a722019-02-12 15:52:36 -08001944 done
1945
1946 allowed_files=
1947 [ -n "$allowed" ] && allowed_files=$(cat "$allowed")
Jim Tanga881a252018-06-19 16:34:41 +08001948 for dir in device vendor product; do
Patrice Arrudaaa4b8242020-10-12 21:29:14 +00001949 for f in $(cd "$T" && test -d $dir && \
Jim Tanga881a252018-06-19 16:34:41 +08001950 find -L $dir -maxdepth 4 -name 'vendorsetup.sh' 2>/dev/null | sort); do
Dan Willemsend855a722019-02-12 15:52:36 -08001951
1952 if [[ -z "$allowed" || "$allowed_files" =~ $f ]]; then
Patrice Arrudaaa4b8242020-10-12 21:29:14 +00001953 echo "including $f"; . "$T/$f"
Dan Willemsend855a722019-02-12 15:52:36 -08001954 else
1955 echo "ignoring $f, not in $allowed"
1956 fi
Jim Tanga881a252018-06-19 16:34:41 +08001957 done
1958 done
1959}
Kenny Root52aa81c2011-07-15 11:07:06 -07001960
Dan Albertbab814f2020-08-26 15:34:53 -07001961function showcommands() {
1962 local T=$(gettop)
1963 if [[ -z "$TARGET_PRODUCT" ]]; then
1964 >&2 echo "TARGET_PRODUCT not set. Run lunch."
1965 return
1966 fi
1967 case $(uname -s) in
1968 Darwin)
1969 PREBUILT_NAME=darwin-x86
1970 ;;
1971 Linux)
1972 PREBUILT_NAME=linux-x86
1973 ;;
1974 *)
1975 >&2 echo Unknown host $(uname -s)
1976 return
1977 ;;
1978 esac
1979 if [[ -z "$OUT_DIR" ]]; then
1980 if [[ -z "$OUT_DIR_COMMON_BASE" ]]; then
1981 OUT_DIR=out
1982 else
1983 OUT_DIR=${OUT_DIR_COMMON_BASE}/${PWD##*/}
1984 fi
1985 fi
1986 if [[ "$1" == "--regenerate" ]]; then
1987 shift 1
1988 NINJA_ARGS="-t commands $@" m
1989 else
1990 (cd $T && prebuilts/build-tools/$PREBUILT_NAME/bin/ninja \
1991 -f $OUT_DIR/combined-${TARGET_PRODUCT}.ninja \
1992 -t commands "$@")
1993 fi
1994}
1995
Jim Tanga881a252018-06-19 16:34:41 +08001996validate_current_shell
1997source_vendorsetup
Kenny Root52aa81c2011-07-15 11:07:06 -07001998addcompletions